package com.brilliance.ccbank.common;

import java.util.HashMap;
import java.util.Map;

import com.brilliance.eibs.core.model.IConnectionDef;
import com.brilliance.eibs.core.model.IStepDef;
import com.brilliance.eibs.core.model.impl.ConnectionDef;

public class ConnectionUtil {
	public static IConnectionDef getConnectionDef(IStepDef stepDef,String ref,String id,String excuteClass,String type,String encoding,Map<String, String> map){
		IConnectionDef connectionDef = new ConnectionDef();
		connectionDef.setParentDef(stepDef);
	    connectionDef.setRef(ref);
	    connectionDef.setId(id);
	    connectionDef.setType(type);
	    connectionDef.setEncoding(encoding);
	    connectionDef.setExecuteClass(excuteClass);
		if(!map.isEmpty()){
			for(Map.Entry<String, String> entry:map.entrySet()){
				connectionDef.addProperty(entry.getKey(), entry.getValue());
			}
		}	
		return connectionDef;
	}
	
	public static IConnectionDef getSocketClientConnectionDef(IStepDef stepDef,String type,String encoding,Map<String, String> map){
		String ref="socketClientConnection";
		String id="socketClientConnection";
		String excuteClass="SocketClientConnection";
		
		return getConnectionDef(stepDef, ref, id, excuteClass, type, encoding, map);
	}
	
	public static IConnectionDef getSocketClientConnectionDef(IStepDef stepDef,String type,Map<String, String> map){
		String encoding="UTF-8";
		return getSocketClientConnectionDef(stepDef, type, encoding, map);
	}
	
	public static IConnectionDef getSocketClientConnectionDef(IStepDef stepDef,String type,String encoding,String ip,String port,String connectTimeout,String receiveTimeout){
		Map<String, String> map = new HashMap<String, String>();
		map.put("ip", ip);
		map.put("port", port);
		map.put("connectTimeout", connectTimeout);
		map.put("receiveTimeout", receiveTimeout);
		
		return getSocketClientConnectionDef(stepDef, type, encoding, map);
	}
	
	public static IConnectionDef getSocketClientConnectionDef(IStepDef stepDef,String type,String ip,String port,String connectTimeout,String receiveTimeout){
		String encoding="UTF-8";
		return getSocketClientConnectionDef(stepDef, type, encoding, ip, port, connectTimeout, receiveTimeout);
	}
	
	public static IConnectionDef getSocketClientConnectionDef(IStepDef stepDef,String type,String ip,String port){
		String connectTimeout="20000";
		String receiveTimeout="20000";
		
		return getSocketClientConnectionDef(stepDef, type, ip, port, connectTimeout, receiveTimeout);
	}
	
	
}
