package com.brilliance.ccbank.service;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import com.brilliance.ccbank.common.CommonUtil;
import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IArgumentDef;
import com.brilliance.eibs.core.model.ICallDef;
import com.brilliance.eibs.core.model.IFieldDef;
import com.brilliance.eibs.core.model.IFilterDef;
import com.brilliance.eibs.core.model.IInterfaceDef;
import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.core.model.IStepDef;
import com.brilliance.eibs.core.model.impl.ArgumentDef;
import com.brilliance.eibs.core.model.impl.CallDef;
import com.brilliance.eibs.core.model.impl.StepDef;

public class CiticbankServer
{

  public IInterfaceDef getccbankServer(IServiceDef serviceDef)
  {
    String id = serviceDef.getId();
    IStepDef stepDef = new StepDef();
    IInterfaceDef interfaceDef = CommonUtil.getInterfaceDef(id, stepDef);
    List<IAbsDef> executeList = new LinkedList<IAbsDef>();
    stepDef.setExecuteList(executeList);

    IFilterDef filterDef = CommonUtil.getFilter("socketFilter", "SocketFilter", "in", stepDef);
    filterDef.setParentDef(stepDef);
    executeList.add(filterDef);
    interfaceDef.addFilters(filterDef);

    IFieldDef fieldDef = CommonUtil.getFieldDef("len", "6", null, "int", "transaction");
    filterDef.addSub(fieldDef);

    fieldDef = CommonUtil.getFieldDef("data", CommonUtil.elStr("len"), null, "String", "transaction");
    filterDef.addSub(fieldDef);

    filterDef = CommonUtil.getFilter("publicFilter", "PublicFilter", "in", stepDef);
    filterDef.setParentDef(stepDef);
    executeList.add(filterDef);
    interfaceDef.addFilters(filterDef);

    ICallDef callDef = new CallDef();
    callDef.setParentDef(filterDef);
    callDef.setType("sub");
    callDef.setInterfaceName("__trndispatch");
    callDef.setTransactionName("__trndispatch");
    List<IArgumentDef> args = new ArrayList<IArgumentDef>();
    IArgumentDef argumentDef = new ArgumentDef();
    argumentDef.setValue("${len}");
    args.add(argumentDef);
    argumentDef = new ArgumentDef();
    argumentDef.setValue("${data}");
    args.add(argumentDef);
    callDef.setArguments(args);
    filterDef.addSub(callDef);

    return interfaceDef;
  }
}
