package com.brilliance.ccbank.service;

import java.util.LinkedList;
import java.util.List;

import org.apache.ibatis.session.SqlSession;
import org.slf4j.Logger;
import org.dom4j.DocumentException;

import com.brilliance.ccbank.dao.TSvrRgstMapper;
import com.brilliance.ccbank.model.TSvrRgst;
import com.brilliance.eibs.core.exception.InterfaceException;
import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.core.model.converter.BeBean2Xml;
import com.brilliance.eibs.core.model.impl.ServiceDef;
import com.brilliance.eibs.factory.BeanFactory;
import com.brilliance.eibs.factory.parser.impl.SessionFactory;

/***
 * 获取服务信息
 * 
 * @author ge
 *
 */
public class ManagerService {
	private static Logger logger = null;

	public ManagerService(Logger logger) {
		ManagerService.logger = logger;
	}

	public List<IServiceDef> getServiceDefs(BeanFactory beanFactory) {
		List<IServiceDef> serviceDefs = new LinkedList<IServiceDef>();
		SqlSession session = SessionFactory.getSession();
		// 查找服务信息
		TSvrRgstMapper svrRgstMapper = session.getMapper(TSvrRgstMapper.class);

		List<TSvrRgst> list = svrRgstMapper.selSvrRgstInfo();
		session.close();
		for (TSvrRgst svrRegister : list) {
			IServiceDef serviceDef = new ServiceDef();
			String id = "citicbank_" + svrRegister.getPort();
			serviceDef.setId(id);
			serviceDef.setEncoding("UTF-8");
			serviceDef.setType("socket");
			serviceDef.setState("on");
			serviceDef.addProperty("trust_ip", "*");
			serviceDef.addProperty("port", svrRegister.getPort().toString());
			serviceDef.addProperty("type", "mina");
			serviceDef.addProperty("request_queue_len", "200");
			serviceDef.addProperty("thread_pool_size", "15");
			serviceDef.addProperty("interfaceName", id);
			serviceDef.addProperty("transactionName", id);
			serviceDef.addProperty("receive_timeout", "0");
			serviceDefs.add(serviceDef);
		}
		BeBean2Xml be2xml = new BeBean2Xml();
		try {
			be2xml.servicedef2XmlFile(serviceDefs);
		} catch (DocumentException e) {
			logger.error("生成服务端XML失败：", e);
			throw new InterfaceException("10000", "system accur error!");
		}

		return serviceDefs;
	}

}