package com.brilliance.ext.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;

public class CsvUtil {

	/**
	 * 生成为CVS文件
	 * 
	 * @param exportData
	 *            源数据List
	 * @param fileds
	 * @param map
	 *            csv文件的列表头map
	 * @param outPutPath
	 *            文件路径
	 * @param fileName
	 *            文件名称
	 * @return
	 */
	@SuppressWarnings("rawtypes")
	public static File createCSVFile(List exportData, String[] fileds, LinkedHashMap map, String outPutPath, String fileName) {
		File csvFile = null;
		BufferedWriter csvFileOutputStream = null;
		try {
			File file = new File(outPutPath);
			if (!file.exists()) {
				file.mkdir();
			}
			// 定义文件名格式并创建
			csvFile = File.createTempFile(fileName, ".csv", new File(outPutPath));
			System.out.println("csvFile：" + csvFile);
			// UTF-8使正确读取分隔符","
			csvFileOutputStream = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(csvFile), "GBK"), 1024);
			System.out.println("csvFileOutputStream：" + csvFileOutputStream);
			// 写入文件头部
			for (Iterator propertyIterator = map.entrySet().iterator(); propertyIterator.hasNext();) {
				java.util.Map.Entry propertyEntry = (java.util.Map.Entry) propertyIterator.next();
				csvFileOutputStream.write((String) propertyEntry.getValue() != null ? new String(((String) propertyEntry.getValue()).getBytes("GBK"),
						"GBK") : "");
				if (propertyIterator.hasNext()) {
					csvFileOutputStream.write(",");
				}
				System.out.println(new String(((String) propertyEntry.getValue()).getBytes("GBK"), "GBK"));
			}
			csvFileOutputStream.write("\r\n");
			// 写入文件内容,
			// ============ //第一种格式：Arraylist<实体类>填充实体类的基本信息==================
			/*
			 * for (int j = 0; exportData != null && !exportData.isEmpty() && j
			 * < exportData.size(); j++) { BankWageMonth t = (BankWageMonth)
			 * exportData.get(j); Class clazz = t.getClass(); String[] contents
			 * = new String[fileds.length]; for (int i = 0; fileds != null && i
			 * < fileds.length; i++) { String filedName =
			 * toUpperCaseFirstOne(fileds[i]); Method method =
			 * clazz.getMethod(filedName); method.setAccessible(true); Object
			 * obj = method.invoke(t); String str = String.valueOf(obj); if (str
			 * == null || str.equals("null")) str = ""; contents[i] = str;
			 * 
			 * }
			 * 
			 * for (int n = 0; n < contents.length; n++) { // 将生成的单元格添加到工作表中
			 * csvFileOutputStream.write(contents[n]);
			 * csvFileOutputStream.write(",");
			 * 
			 * } csvFileOutputStream.write("\r\n"); }
			 */

			// ============ //第二种格式：Arraylist<map>填充实体类的基本信息==================
			for (Iterator iterator = exportData.iterator(); iterator.hasNext();) {
				Object row = (Object) iterator.next();
				for (Iterator propertyIterator = map.entrySet().iterator(); propertyIterator.hasNext();) {
					java.util.Map.Entry propertyEntry = (java.util.Map.Entry) propertyIterator.next();
					csvFileOutputStream.write((String) BeanUtils.getProperty(row,
							((String) propertyEntry.getKey()) != null ? (String) propertyEntry.getKey() : ""));
					if (propertyIterator.hasNext()) {
						csvFileOutputStream.write(",");
					}
				}
				if (iterator.hasNext()) {
					csvFileOutputStream.write("\r\n");
				}
			}

			// =================================
			csvFileOutputStream.flush();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				csvFileOutputStream.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return csvFile;
	}

	public static void main(String[] args) {
		LinkedHashMap map = new LinkedHashMap();
		map.put("1", "第一列");
		map.put("2", "第二列");
		map.put("3", "第三列");
		map.put("4", "第四列");

		List exportData = new ArrayList<Map>();

		for (int i = 0; i < 200000; i++) {
			Map row1 = new LinkedHashMap<String, String>();
			row1.put("1", "21");
			row1.put("2", "22");
			row1.put("3", "23");
			row1.put("4", "24");
			exportData.add(row1);
		}
		long d1 = System.currentTimeMillis();
		String path = "D://export//";
		String fileName = "文件导出";
		String fileds[] = new String[] { "id", "number" };// 设置列英文名（也就是实体类里面对应的列名）
		File file = CsvUtil.createCSVFile(exportData, fileds, map, path, fileName);
		String fileName2 = file.getName();
		System.out.println("文件名称：" + fileName2);
		long d2 = System.currentTimeMillis();
		System.out.println((d2 - d1) / 1000);
	}

}
