package com.brilliance.ext.util;

import java.util.Map;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ConcurrentHashMap;

public class QueueTask {
	private static Map<String, BlockingQueue<Object>> queue = new ConcurrentHashMap<String, BlockingQueue<Object>>();

	public static void createBlockingQueue(String key, int capacity, boolean fair) {
		if (queue.containsKey(key))
			return;
		queue.put(key, new ArrayBlockingQueue<Object>(capacity, fair));
	}

	public static Object takeFromBlockingQueue(String key) throws Exception {
		Object obj = null;
		if (queue.get(key) == null)
			return obj;
		return queue.get(key).take();
	}

	public static boolean put2BlockingQueue(String key, Object obj) throws Exception {
		if (queue.get(key) == null)
			return false;
		queue.get(key).put(obj);
		return true;
	}
}
