<#-- 导入可执行单元模板 -->
<#import "/filter.ftl" as filter>
<#import "/func.ftl" as func>
<#-- PublicFilter组件 -->
<#macro PublicFilter comp>
<#list comp.pars.executableunits as eu>
<@filter.ExecutableUnit pars=eu type=comp.type encode=comp.encode/>
</#list>
</#macro>

<#-- XmlFilter组件 -->
<#macro XmlFilter comp>
	<#assign XmlFilterTag=methodkit("declareVariables", "doc", "org.dom4j.Document", "", currentFilter, transactionName)/>
	${XmlFilterTag} = null;
	<#if comp.type=="in">
		doc = DocumentHelper.parseText(ctx.getObject().toString());
	<#else>
		<#if comp.commonspropertymap?? && comp.commonspropertymap.doc?? && comp.commonspropertymap.doc=="true">
			doc = DocumentHelper.parseText(ctx.getObject().toString());
		</#if>
	</#if>
	<#list comp.pars.executableunits as eu>
		<@filter.ExecutableUnit pars=eu type=comp.type encode=comp.encode/>
	</#list>
	<#if comp.type=="out">
		ctx.setObject(ExecutableUnit.format(doc));
		logger.info(ctx, "XML报文组装的报文:" + ctx.getObject());
	</#if>
</#macro>

<#-- FixedFilter组件 -->
<#macro FixedFilter comp>
	<#assign fixedfilterbytes=methodkit("declareVariables", "__bytes", "byte[]", "", currentFilter, transactionName)/>
	${fixedfilterbytes} = null;
	<#if comp.commonspropertymap??>
		ExecutableUnit.fixedFilterInitial(<@func.toString tmp=comp.encode/>,<@func.toString tmp=comp.commonspropertymap.number_fillchar!/>,<@func.toString tmp=comp.commonspropertymap.string_fillchar!/>,<@func.toString tmp=comp.commonspropertymap.fill_number_strategy!/>,<@func.toString tmp=comp.commonspropertymap.fill_string_strategy!/>,ctx);
	<#else>
		ExecutableUnit.fixedFilterInitial(<@func.toString tmp=comp.encode/>,"","","","",ctx);
	</#if>
	<#if comp.type=="in">
		object = ctx.getObject();
		if (object instanceof byte[]) {
			bytes = (byte[]) object;
		} else {
			bytes = ((String)ctx.getObject()).getBytes((String)ctx.getVariable(ExecutableUnit.ENCODEING));
		}
	</#if>
</#macro>

<#-- FileConnection组件 -->
<#macro FileConnection comp>
<#if comp.type=="in">
<#if comp.pars.type?? && !(comp.pars.removeLines??)>
			object = ExecutableUnit.readFile(${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.path, currentFilter, transactionName)}.toString(), ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.type, currentFilter, transactionName)}, ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.encode, currentFilter, transactionName)});
<#elseif comp.pars.type?? && comp.pars.removeLines??>
			object = ExecutableUnit.readFile(${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.path, currentFilter, transactionName)}.toString(), ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.type, currentFilter, transactionName)}, ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.encode, currentFilter, transactionName)}, ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.removeLines, currentFilter, transactionName)});
<#else>
			object = ExecutableUnit.readFile(${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.path, currentFilter, transactionName)}.toString(), ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.encode, currentFilter, transactionName)});
</#if>
			ctx.setObject(object);
<#else>
<#if comp.pars.append??>
			ExecutableUnit.writeFile(${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.path, currentFilter, transactionName)}, ctx.getObject(), ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.encode, currentFilter, transactionName)}, ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.append, currentFilter, transactionName)});
<#else>
			ExecutableUnit.writeFile(${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.pars.path, currentFilter, transactionName)}, ctx.getObject(), ${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.encode, currentFilter, transactionName)});
</#if>
</#if>
</#macro>

<#-- JdbcConnection组件 -->
<#macro JdbcConnection comp>
<#if comp.joinedid?? && comp.joinedid!="">
	ctx.getResource().setConnection(ExecutableUnit.createConnectionJoined(<@func.toString tmp=interfaceName!/>,<@func.toString tmp=transactionName!/>,<@func.toString tmp=comp.id!/>,${methodkit("handleExpression", "", "", comp.pars.url!, currentFilter, transactionName)},ctx));
<#else>
<#assign jdbcurl=methodkit("handleExpression", "", "", comp.pars.url!, currentFilter, transactionName)/>
	ctx.getResource().setConnection(ExecutableUnit.createConnection(<@func.toString tmp=interfaceName!/>,<@func.toString tmp=transactionName!/>,<@func.toString tmp=comp.id!/>,${jdbcurl},ctx));
<#if comp.pars.use_table_cnt?? && comp.pars.use_table_cnt=="true">
	ctx.getResource().setCntConnection(ExecutableUnit.createConnection(<@func.toString tmp=interfaceName!/>,<@func.toString tmp=transactionName!/>,<@func.toString tmp=comp.id!/>+ "_cnt",${jdbcurl},ctx));
</#if>
</#if>
	ctx.getResource().setExecutor(new JdbcExecutor(ctx, ctx.getResource().getConnection()));
</#macro>

<#-- SqlFilter组件 -->
<#macro SqlFilter comp>
<#list comp.pars.executableunits as eu>
<@filter.ExecutableUnit pars=eu type=comp.type encode=comp.encode/>
</#list>
</#macro>