<#import "/filter.ftl" as filter>
<#import "/component.ftl" as com>

<#-- ***处理filter和connections的核心部分*** -->
<#macro handleComponent components>
<#list components as comp>
<#global currentFilter=comp.ref>
<#if (comp.via)?? && comp.via!="">
			ctx.setObject(${methodkit("handleExpression", comp.pars.tag!, comp.pars.type!, comp.via, currentFilter, transactionName)});
</#if>
<#-- 处理if部分 -->
<#if (comp.ref)?? && comp.ref=="if">
<#assign ifmap = comp.conditionMap>
<#assign firstflag = true>
<#list ifmap?keys as key>
<#assign curlist = ifmap[key]>
<#if firstflag>
<#assign firstflag = false>
	if(${methodkit("handleExpression", "", "", key, currentFilter!, transactionName)}){
		<@handleComponent components=curlist/>
	}
<#else>
	else if(${methodkit("handleExpression", "", "", key, currentFilter!, transactionName)}){
		<@handleComponent components=curlist/>
	}
</#if>
</#list>
<#if comp.elseCondition?? && (comp.elseCondition?size >0)>
<#assign curlist = comp.elseCondition>
	else{
		<@handleComponent components=curlist/>
	}
</#if>
<#-- 处理foreach部分 -->
<#elseif (comp.ref)?? && comp.ref=="foreach">
<#assign combeginValue = methodkit("handleExpression", comp.tag!, comp.type!, comp.begin, currentFilter, transactionName)>
<#assign compendValue = methodkit("handleExpression", comp.tag!, comp.type!, comp.end, currentFilter, transactionName)>
<#assign compstepValue = methodkit("handleExpression", comp.tag!, comp.type!, comp.step, currentFilter, transactionName)>
<#if comp.condition?? && comp.condition!="">
<#assign compcondition = "&&"+methodkit("handleExpression", comp.tag!, comp.type!, comp.condition, currentFilter, transactionName)>
</#if>
	for(int ${comp.tag} = ${combeginValue}; ${comp.tag} < ${compendValue} ${compcondition!}; ${comp.tag} += ${compstepValue}){
		<@handleComponent components=comp.subList/>
	}
<#-- 处理while部分 -->
<#elseif (comp.ref)?? && comp.ref=="while">
<#if comp.condition?? && comp.condition!="">
<#assign whilecondition = methodkit("handleExpression", comp.tag!, comp.type!, comp.condition, currentFilter, transactionName)>
<#else>
<#assign whilecondition = false>
</#if>
	while(${whilecondition}){
		<@handleComponent components=comp.subList/>
	}
<#-- 处理PublicFilter部分 -->
<#elseif (comp.ref)?? && comp.ref=="PublicFilter">
<@com.PublicFilter comp=comp/>
<#-- 处理XmlFilter部分 -->
<#elseif (comp.ref)?? && comp.ref=="XmlFilter">
<@com.XmlFilter comp=comp/>
<#-- 处理FixedFilter部分 -->
<#elseif (comp.ref)?? && comp.ref=="FixedFilter">
<@com.FixedFilter comp=comp/>
<#-- 处理FileConnection部分 -->
<#elseif (comp.ref)?? && comp.ref=="FileConnection">
<@com.FileConnection comp=comp/>
<#-- 处理JdbcConnection部分 -->
<#elseif (comp.ref)?? && comp.ref=="JdbcConnection">
<@com.JdbcConnection comp=comp/>
<#-- 处理SqlFilter部分 -->
<#elseif (comp.ref)?? && comp.ref=="SqlFilter">
<@com.SqlFilter comp=comp/>
<#else>
			no matched:[${comp.ref!}]
</#if>
</#list>
</#macro>

<#-- 对获取到的值，进行二次加工，譬如转换类型，码表转换等等 -->
<#macro handleVal par encode>
<#assign handlevalflag=false/>
<#assign tcurtag=methodkit("declareVariables", par.tag!, par.type!, par.value!, currentFilter, transactionName)/>
<#assign curtag=methodkit("declareVariables", par.tag!, par.type!, par.value!, currentFilter, transactionName)/>
<#-- 处理type用来创建对象这一特殊转换 -->
<#if par.type?? && methodkit("matches", par.type, "\\$\\{\\S+\\s*=new\\s+\\(\\S+\\)\\}")>
<#assign handlevalflag=true/>
			${tcurtag} = ${methodkit("createObjBytype", par.type, "\\$\\{\\S+\\s*=new\\s+\\((\\S+)\\)\\}")};
<#elseif par.type?? && methodkit("matches", par.type, "\\$\\{new\\s+\\S+\\(\\S*\\)\\}")>
<#assign handlevalflag=true/>
			${tcurtag} = ${methodkit("createObjBytype", par.type, "\\$\\{new\\s+(\\S+)(\\(\\S*\\))\\}")};
<#elseif par.type?? && methodkit("matches", par.type, "(\\w+)(\\[\\d+\\])+")>
<#assign handlevalflag=true/>
			${tcurtag} = ${methodkit("createArrayByType", par.type, "(\\w+)(\\[\\d+\\])+")};
<#elseif par.type?? && par.type?lower_case=="arraylist" && (!(par.value??) || par.value="")>
<#assign handlevalflag=true/>
			List<Object> ${curtag} = new ArrayList<Object>();
<#elseif par.type?? && par.type?lower_case=="map" && (!(par.value??) || par.value="")>
<#assign handlevalflag=true/>
			Map<Object, Object> ${curtag} = new HashMap<Object, Object>();
<#elseif par.type?? && par.type?lower_case=="linkedmap" && (!(par.value??) || par.value="")>
<#assign handlevalflag=true/>
			Map<Object, Object> ${curtag} = new LinkedHashMap<Object, Object>();
</#if>
<#-- 1.处理value属性 -->
<#if par.value?? && par.value!="">
<#assign handlevalflag=true/>
			${tcurtag} = ${methodkit("handleExpression", par.tag!, par.type!, par.value, currentFilter, transactionName)};
</#if>
<#-- 2.处理validator属性 -->
<#if par.validator?? && par.validator!="">
			if (!StringUtil.isEmpty(${methodkit("handleExpression", par.tag!, par.type!, par.validator, currentFilter, transactionName)}) && ${curtag} != null && !${curtag}.toString().matches(${methodkit("handleExpression", par.tag!, par.type!, par.validator, currentFilter, transactionName)})) {
				throw new InterfaceException("00431", "field value [" + ${curtag} + "] does not match regex [" + ${methodkit("handleExpression", par.tag!, par.type!, par.validator, currentFilter, transactionName)} + "]");
			}
</#if>
<#-- 3.处理codetable属性 -->
<#if par.codetable?? && par.codetable!="">
			${curtag} = ctx.getCodeTableValue(${methodkit("handleExpression", par.tag!, par.type!, par.codetable, currentFilter, transactionName)}, ${curtag}.toString());
</#if>
<#-- 4.处理direct属性 -->
<#if par.direct?? && par.direct!="">
<#assign handlevalflag=true/>
<#assign direct=par.direct/>
<#if direct?? && direct=="i">
			ctx.getInputMap().put(<@toString tmp=par.tag/>, ${curtag});
<#elseif direct?? && direct=="o">
			ctx.getOutputMap().put(<@toString tmp=par.tag/>, ${curtag});
</#if>
</#if>
<#if handlevalflag>
<#if par.scope?? && par.scope=="this">
			ctx.setObject(${curtag});
</#if>
</#if>
</#macro>

<#-- log标签处理 -->
<#macro log par>
<#if par.level?? && par.level!="">
	logger.${par.level}(ctx, ${methodkit("handleExpression", par.tag!, par.type!, par.value, currentFilter, transactionName)});
<#else>
	logger.info(ctx, ${methodkit("handleExpression", par.tag!, par.type!, par.value, currentFilter, transactionName)});
</#if>
</#macro>

<#-- filter内部if标签处理 -->
<#macro handleif par encode type>
<#assign filterifmap = par.conditionMap>
<#assign firstflag = true>
<#-- 处理if和else if -->
<#list filterifmap?keys as key>
<#assign filtercurlist = filterifmap[key]>
<#if firstflag>
<#assign firstflag = false>
	if(${methodkit("handleExpression", "", "", key, currentFilter!, transactionName)}){
		<@handlesublist lst=filtercurlist encode=encode type=type/>
	}
<#else>
	else if(${methodkit("handleExpression", "", "", key, currentFilter!, transactionName)}){
		<@handlesublist lst=filtercurlist encode=encode type=type/>
	}
</#if>
</#list>
<#-- 处理else -->
<#if par.elseCondition?? && (par.elseCondition?size >0)>
<#assign filtercurlist = par.elseCondition>
	else{
		<@handlesublist lst=filtercurlist encode=encode type=type/>
	}
</#if>
</#macro>

<#-- filter内部foreach标签处理 -->
<#macro handleforeach par encode type>
<#if par.begin?? && par.begin!="">
<#assign beginValue = methodkit("handleExpression", par.tag!, par.type!, par.begin, currentFilter, transactionName)>
<#else>
<#assign beginValue = 0>
</#if>
<#if par.step?? && par.step!="">
<#assign stepValue = methodkit("handleExpression", par.tag!, par.type!, par.step, currentFilter, transactionName)>
<#else>
<#assign stepValue = 1>
</#if>
<#if par.end?? && par.end!="">
<#assign endValue = methodkit("handleExpression", par.tag!, par.type!, par.end, currentFilter, transactionName)>
<#else>
<#assign endValue = 0>
</#if>
<#if par.condition?? && par.condition!="">
<#assign condition = "&&"+methodkit("handleExpression", par.tag!, par.type!, par.condition, currentFilter, transactionName)>
</#if>
	for(int ${par.tag} = ${beginValue}; ${par.tag} < ${endValue} ${condition!}; ${par.tag} += ${stepValue}){
		<@handlesublist lst=par.subList encode=encode type=type/>
	}
</#macro>

<#-- filter内部while标签处理 -->
<#macro handlewhile par encode type>
<#if par.condition?? && par.condition!="">
<#assign filterwhilecondition = methodkit("handleExpression", par.tag!, par.type!, par.condition, currentFilter, transactionName)>
<#else>
<#assign filterwhilecondition = false>
</#if>
	while(${filterwhilecondition}){
		<@handlesublist lst=par.subList encode=encode type=type/>
	}
</#macro>

<#-- filter内部call标签处理 -->
<#macro handlecall par encode type>
<#if web=true>
	<#assign tcurtag=methodkit("declareVariables", par.tag!, "string", par.value!, currentFilter, transactionName)/>
	<#-- webservice模式的call标签处理 -->
	<#if par.mode?? && par.mode=="S">
		ExecutableUnit.asynCallMethod(ctx, new ${par.interfaceName?cap_first}Imp(), <@toString tmp=par.transactionName/>,new Object[] {new com.google.gson.Gson().toJson(${par.arguments[0].value!})});
	<#else>
		${tcurtag} = new ${par.interfaceName?cap_first}Imp().${par.transactionName}(new com.google.gson.Gson().toJson(${par.arguments[0].value!}));
	</#if>
<#else>
	<#assign tcurtag=methodkit("declareVariables", par.tag!, "object", par.value!, currentFilter, transactionName)/>
	<#if par.mode?? && par.mode=="S">
		ExecutableUnit.asynCallMethod(ctx, new ${par.interfaceName?cap_first}Imp(), <@toString tmp=par.transactionName/>,new Object[] {
	<#else>
		<#-- 常规模式的call标签处理 -->
		${tcurtag} = new ${par.interfaceName?cap_first}Imp().${par.transactionName}(
	</#if>
	new Object[]{
		<#list par.arguments as argument>
		<#assign isnotlast=argument_index != (par.arguments?size-1)/>
		<#if argument.type?? && argument.type!="">
			(${methodkit("formatType",argument.type!)})(${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)})<#if isnotlast>,</#if>
		<#else>
			${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)}<#if isnotlast>,</#if>
		</#if>
		</#list>
	<#if par.mode?? && par.mode=="S">
		}});
	<#else>
		});
	</#if>
</#if>
</#macro>

<#-- filter内部validator标签处理 -->
<#macro handlevalidator par encode type>
<#if par.condition?? && par.condition!="">
<#assign filtervalidatorcondition = methodkit("handleExpression", "", "", par.condition, currentFilter, transactionName)>
<#else>
<#assign filtervalidatorcondition = true>
</#if>
	if(!(${filtervalidatorcondition})){
		ctx.getResource().setErrorcode(<@toString tmp=par.errorCode!/>);
		ctx.getResource().setDescription(<@toString tmp=par.description!/>);
		throw new InterfaceException(<@toString tmp=par.errorCode!/>,<@toString tmp=par.description!/>);
	}
</#macro>

<#-- 批量转换field,if,log等等标签 -->
<#macro handlesublist lst encode type>
<#list lst as comp>
	<#if currentFilter?? && currentFilter=="PublicFilter">
		<@filter.ExecutableUnit pars=comp type=type encode=encode/>
	<#elseif currentFilter?? && currentFilter=="XmlFilter">
		<@filter.ExecutableUnit pars=comp type=type encode=encode/>
	</#if>
</#list>
</#macro>

<#-- 为字符串添加双引号 -->
<#macro toString tmp>${"\""+tmp+"\""}</#macro>