package com.brilliance.eibs.bean;

import com.brilliance.eibs.core.model.IBean;

/**
 * bean对象 
 * JavaBean Interface接口 实现类的配置都可以继承
 * 该类 
 * 
 * @author yangrui
 *
 */
public abstract class Bean
    implements IBean
{
  private static final long serialVersionUID = 1L;

  protected String          className;
  protected String          packageName;
  protected String          ImplName;
  protected String          tagetNameSpace;
  protected String          wsdlLocation;
  protected String          serviceName;
  protected StringBuffer    sb               = new StringBuffer();

  public String getClassName()
  {
    return className;
  }

  public void setClassName(String className)
  {
    this.className = className;
  }

  public String getPackageName()
  {
    return packageName;
  }

  public void setPackageName(String packageName)
  {
    this.packageName = packageName;
  }

  public String getImplName()
  {
    return ImplName;
  }

  public void setImplName(String ImplName)
  {
    this.ImplName = ImplName;
  }

  public String getTagetNameSpace()
  {
    return tagetNameSpace;
  }

  public String getWsdlLocation()
  {
    return wsdlLocation;
  }

  public void setTagetNameSpace(String tagetNameSpace)
  {
    this.tagetNameSpace = tagetNameSpace;
  }

  public void setWsdlLocation(String wsdlLocation)
  {
    this.wsdlLocation = wsdlLocation;
  }

  public StringBuffer getSb()
  {
    return sb;
  }

  /**
   * 输出文件内容
   */
  public abstract void execute();

  @Override
  public boolean equals(Object obj)
  {
    if (obj == this)
      return true;
    if (!(obj instanceof Bean))
      return false;
    Bean bean = (Bean) obj;
    return bean.getClassName().equals(className) && bean.getPackageName().equals(packageName);
  }

  public String getServiceName()
  {
    return serviceName;
  }

  public void setServiceName(String serviceName)
  {
    this.serviceName = serviceName;
  }
}
