package com.brilliance.eibs.coder;

import java.security.*;
import java.util.HashMap;
import java.util.Map;

/**
 * @author hujun
 * 非对称加密
 *
 */
public class AsymmetryCoder
    extends Coder
{

  protected static final String PUBLIC_KEY  = "publicKey";
  protected static final String PRIVATE_KEY = "privateKey";

  protected static Map<String, Object> generateKey(String strKey, int keySize, String algorithm)
      throws NoSuchAlgorithmException
  {
    KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance(algorithm);
    keyPairGenerator.initialize(keySize, getSecureRandom(strKey));
    KeyPair keyPair = keyPairGenerator.generateKeyPair();
    PublicKey publicKey = keyPair.getPublic();
    PrivateKey privateKey = keyPair.getPrivate();
    Map<String, Object> keyMap = new HashMap<String, Object>(2);
    keyMap.put(PUBLIC_KEY, publicKey);
    keyMap.put(PRIVATE_KEY, privateKey);
    return keyMap;
  }

  public static byte[] getPrivateKey(Map<String, Object> keyMap)
  {
    Key key = (Key) keyMap.get(PRIVATE_KEY);
    return key.getEncoded();
  }

  public static byte[] getPublicKey(Map<String, Object> keyMap)
  {
    Key key = (Key) keyMap.get(PUBLIC_KEY);
    return key.getEncoded();
  }
}
