package com.brilliance.eibs.coder;

import java.security.*;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

/**
 * @author hujun
 *
 */
public class SignCoder
{

  public static byte[] sign(byte[] data, byte[] privateKey, String algorithm, String signature_algorithm)
      throws NoSuchAlgorithmException, InvalidKeySpecException, InvalidKeyException, SignatureException
  {
    PKCS8EncodedKeySpec pkcs8KeySpec = new PKCS8EncodedKeySpec(privateKey);
    KeyFactory keyFactory = KeyFactory.getInstance(algorithm);
    PrivateKey priKey = keyFactory.generatePrivate(pkcs8KeySpec);
    Signature signature = Signature.getInstance(signature_algorithm);
    signature.initSign(priKey);
    signature.update(data);
    return signature.sign();
  }

  public static boolean verify(byte[] data, byte[] publicKey, byte[] sign, String algorithm, String signature_algorithm)
      throws NoSuchAlgorithmException, InvalidKeySpecException, InvalidKeyException, SignatureException
  {
    X509EncodedKeySpec keySpec = new X509EncodedKeySpec(publicKey);
    KeyFactory keyFactory = KeyFactory.getInstance(algorithm);
    PublicKey pubKey = keyFactory.generatePublic(keySpec);
    Signature signature = Signature.getInstance(signature_algorithm);
    signature.initVerify(pubKey);
    signature.update(data);
    return signature.verify(sign);
  }
}
