package com.brilliance.eibs.coder.impl;

import org.apache.commons.codec.binary.Base64;

import java.io.UnsupportedEncodingException;

/**
 * @author hujun
 *
 */
public class Base64Coder
{
  public final static String ENCODING = "UTF-8";

  public static String encode(String data)
      throws UnsupportedEncodingException
  {
    byte[] b = Base64.encodeBase64(data.getBytes(ENCODING));
    return new String(b, ENCODING);
  }

  //遵循RFC 2045实现
  public static String encodeSafe(String data)
      throws UnsupportedEncodingException
  {
    byte[] b = Base64.encodeBase64(data.getBytes(ENCODING), true);
    return new String(b, ENCODING);
  }

  public static String decode(String data)
      throws UnsupportedEncodingException
  {
    byte[] b = Base64.decodeBase64(data.getBytes(ENCODING));
    return new String(b, ENCODING);
  }

  public static byte[] decodeBase64(String data)
      throws UnsupportedEncodingException
  {
    byte[] b = Base64.decodeBase64(data.getBytes(ENCODING));
    return b;
  }
}
