package com.brilliance.eibs.core.debug;

import com.brilliance.eibs.core.frame.IIdentity;
import com.brilliance.eibs.core.frame.instance.IInstance;
import com.brilliance.eibs.core.model.impl.AbsDef;
import com.brilliance.eibs.core.service.Context;

/**
 * @author hujun
 *
 *         debug实例抽象父类
 */
public abstract class AbsDebugInstance implements IInstance {

    private AbsDef t;

    public AbsDebugInstance(AbsDef t) {
        this.t = t;
    }

    @Override
    public void execute(Context context) {
        
        IIdentity identity = context.getIdentity();
        IDebug<AbsDef> debug = AbstractDebugFactory.getDebbug(identity);
        if (DebugMode.singleInstance().isDebug() && null != identity && null != debug) {
            IDebugAdaptor<AbsDef> adaptor = debug.getAdaptor(t);
            if (adaptor.isBreak()) {
                synchronized (adaptor) {
                    adaptor.setContext(context);
                    adaptor.suspend();
                }
            }
        }
        normalProcess(context);
    }

    public abstract void normalProcess(Context context);
}

