package com.brilliance.eibs.core.debug;

/**
 * @author hujun
 *
 *         debug模式类，用于判断当前接口平台是否处于debug调试模式 单例
 */
public class DebugMode {

    private static DebugMode instance;

    public static final String DEBUG_STATUS = "DEBUG";

    private String status;

    public static synchronized DebugMode singleInstance() {
        if (instance == null) instance = new DebugMode();
        return instance;
    }

    public void register(String status) {
        this.status = status;
    }

    public boolean isDebug() {
        if (DEBUG_STATUS.equalsIgnoreCase(status)) return true;
        return false;
    }
}
