package com.brilliance.eibs.core.debug.adapor;

import com.brilliance.eibs.core.debug.IDebugAdaptor;
import com.brilliance.eibs.core.debug.model.Breakpoint;
import com.brilliance.eibs.core.service.Context;

/**
 * @author hujun
 *
 * @param <T>
 * 
 */
public class AbstractDebugAdaptor<T> implements IDebugAdaptor<T> {


    private T t;
    private Breakpoint<T> point;
    private Context context;

    public AbstractDebugAdaptor(T t, Breakpoint<T> point) {
        this.t = t;
        this.point = point;
    }

    @Override
    public void turnOn() {
        point.set();
    }

    @Override
    public void turnOff() {
        point.cancel();
        context = null;
    }

    @Override
    public void suspend() {
        point.suspend();
    }

    @Override
    public boolean isBreak() {
        return point.isBreak();
    }

    @Override
    public Context getContext() {
        return context;
    }

    @Override
    public void setContext(Context context) {
        this.context = context;
    }


}
