package com.brilliance.eibs.core.debug.model;

import com.brilliance.eibs.core.debug.IDebug;

/**
 * @author hujun
 *
 *         断点类
 */
public class Breakpoint<E> {

    private boolean isBreak = false;
    private IDebug<E> debug;

    Breakpoint(IDebug<E> debug) {
        this.debug = debug;
    }

    public void set() {
        isBreak = true;
    }

    public void cancel() {
        isBreak = false;
    }

    public boolean isBreak() {
        return isBreak;
    }

    public void resume() {
        debug.resume();
    }

    public void suspend() {
        if (isBreak) debug.suspend();
    }


}
