package com.brilliance.eibs.core.exception;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 系统错误码列表类,存储和检索系统支持的所有错误码
 * @author xiaoyuanzhen
 */

public class ErrorCodes
    implements Serializable
{
  private static final long serialVersionUID = 1L;

  List<SysCode>             sysCodes         = new ArrayList<SysCode>(); // 系统错误码列表                                      //最近修改时间

  public List<SysCode> getSysCodes()
  {
    return sysCodes;
  }

  public void setSysCodes(List<SysCode> sysCodes)
  {
    this.sysCodes = sysCodes;
  }

  public void addSysCode(SysCode sysCode)
  {
    this.sysCodes.add(sysCode);
    int curSize = this.sysCodes.size();
    int i = 0;
    String id = sysCode.getId();
    for (; i < curSize; i++)
    {
      if (id.equals(this.sysCodes.get(i).getId()))
      {
        this.sysCodes.set(i, sysCode);
        break;
      }
    }
    if (i == curSize)
      this.sysCodes.add(sysCode);
  }

  /**
   * 添加错误码的，相同id的进行覆盖
   * @param sysCodes
   */
  public void addSysCodes(List<SysCode> sysCodes)
  {
    int curSize = this.sysCodes.size();
    for (int i = 0; i < sysCodes.size(); i++)
    {
      SysCode sysCode = sysCodes.get(i);
      String id = sysCode.getId();
      int j = 0;
      for (; j < curSize; j++)
      {
        if (id.equals(this.sysCodes.get(j).getId()))
        {
          this.sysCodes.set(j, sysCode);
          break;
        }
      }
      if (j == curSize)
        this.sysCodes.add(sysCode);
    }
  }

  public boolean equals(Object obj)
  {
    return EqualsBuilder.reflectionEquals(this, obj);
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

}
