package com.brilliance.eibs.core.frame;

import com.brilliance.eibs.core.model.impl.AbsDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @author hujun
 *
 *         接口平台配置模型工厂类
 */
public class AbsDefFactory {
    private static Map<IIdentity, AbsDef> defs = new ConcurrentHashMap<IIdentity, AbsDef>();

    public static AbsDef getDef(String locator, String interfaceName) {
        IIdentity identity = new AbsDefIdentity(locator, interfaceName);
        if (defs.containsKey(identity)) return defs.get(identity);
        return null;
    }

    public static void addDef(String locator, String interfaceName, AbsDef def) {
        defs.put(new AbsDefIdentity(locator, interfaceName), def);
    }

    private static class AbsDefIdentity implements IIdentity {

        @SuppressWarnings("unused")
        private String locator;
        @SuppressWarnings("unused")
        private String interfaceName;

        public AbsDefIdentity(String locator, String interfaceName) {
            this.locator = locator;
            this.interfaceName = interfaceName;
        }

        @Override
        public boolean equals(Object obj) {
            boolean b = EqualsBuilder.reflectionEquals(this, obj);
            return b;
        }

        @Override
        public int hashCode() {
            return HashCodeBuilder.reflectionHashCode(this);
        }

    }
}
