package com.brilliance.eibs.core.model;

import com.brilliance.eibs.core.exception.ErrorCodes;
import com.brilliance.eibs.factory.BeanFactory.FunctionKey;

import java.util.List;
import java.util.Map;
import java.util.ResourceBundle;

/**
 * 接口定义类
 */
public interface IInterfaceDef
    extends IDefinition
{

  public Map<String, IModuleDef> getModuleMap();

  public void setModuleMap(Map<String, IModuleDef> moduleMap);

  public Map<FunctionKey, IFunctionDef> getFunctionMap();

  public void setFunctionMap(Map<FunctionKey, IFunctionDef> functionMap);

  public ResourceBundle getResb();

  public void setResb(ResourceBundle resb);

  public boolean isSingleton();

  public void setSingleton(boolean singleton);

  public String getId();

  public void setId(String id);

  public boolean isInner();

  /**
   * 获取接口描述
   * @return
   */
  public String getDescription();

  /**
   * 设置接口描述
   * @param description
   */
  public void setDescription(String description);

  /**
   * 获取基包,动态配置的实现类要使用
   * @return
   */
  public String getBasePackage();

  /**
   * 设置基包,动态配置的实现类要使用
   * @param basePackage
   */
  public void setBasePackage(String basePackage);

  public String getEncoding();

  public void setEncoding(String encoding);

  public String getLanguage();

  public void setLanguage(String language);

  public List<ITransactionDef> getTransactionDefs();

  public void setTransactionDefs(List<ITransactionDef> transactionDefs);

  public String getType();

  public void setType(String type);

  public String getVersion();

  public void setVersion(String version);

  public ErrorCodes getErrorCodes();

  public void setErrorCodes(ErrorCodes errorCodes);

  public Map<String, Map<String, String>> getCodetableMap();

  public void setCodetableMap(Map<String, Map<String, String>> codetableMap);

  public Map<String, String> getDynamicCodetableMap();

  public void setDynamicCodetableMap(Map<String, String> dynamicCodetableMap);

  public Map<String, ICounterDef> getCountermap();

  public void setCountermap(Map<String, ICounterDef> countermap);

  public Map<FunctionKey, IFuncDef> getFuncMap();

  public void setFuncMap(Map<FunctionKey, IFuncDef> funcMap);

  public String getDefaultScope();

  public void setDefaultScope(String defaultSocpe);

  public String getLogLevel();

  public void setLogLevel(String logLevel);

  public void addFunc(String namespace, String cls, String stc);

  public List<IConnectionDef> getConnections();

  public void setConnections(List<IConnectionDef> connections);

  public void addConnection(IConnectionDef connectionDef);

  public void addFilters(IFilterDef filterDef);

  public List<IFilterDef> getFilters();

  public void setFilters(List<IFilterDef> filters);
}
