package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IForeachDef;
import com.brilliance.eibs.core.model.IPropertyDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import com.thoughtworks.xstream.annotations.XStreamOmitField;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@SuppressWarnings("serial")
@XStreamAlias("foreach")
public class ForeachDef
    extends AbsDef
    implements IForeachDef, Serializable
{
  @XStreamAsAttribute
  private String                    tag;
  @XStreamAsAttribute
  private String                    begin;
  @XStreamAsAttribute
  private String                    end;
  @XStreamAsAttribute
  private String                    condition;
  @XStreamOmitField
  private int                       currentCount;
  @XStreamAsAttribute
  private String                    step;
  @XStreamAsAttribute
  private String                    scope;
  @XStreamOmitField
  private boolean                   ignoreExption;
  @XStreamImplicit
  private List<IAbsDef>              subList      = new ArrayList<IAbsDef>();
  @XStreamOmitField
  private Map<String, IPropertyDef> propertyDefs = new HashMap<String, IPropertyDef>();

  public int getCurrentCount()
  {
    return currentCount;
  }

  public void setCurrentCount(int currentCount)
  {
    this.currentCount = currentCount;
  }

  public Map<String, IPropertyDef> getPropertyDefs()
  {
    return propertyDefs;
  }

  public void addPropertyDef(String key, IPropertyDef propertyDef)
  {
    this.propertyDefs.put(key, propertyDef);
  }

  public String getTag()
  {
    return tag;
  }

  public void setTag(String tag)
  {
    this.tag = tag;
  }

  public String getBegin()
  {
    return begin;
  }

  public void setBegin(String begin)
  {
    this.begin = begin;
  }

  public String getEnd()
  {
    return end;
  }

  public void setEnd(String end)
  {
    this.end = end;
  }

  public String getCondition()
  {
    return condition;
  }

  public void setCondition(String condition)
  {
    this.condition = condition;
  }

  public String getStep()
  {
    return step;
  }

  public void setStep(String step)
  {
    this.step = step;
  }

  public String getScope()
  {
    return scope;
  }

  public void setScope(String scope)
  {
    this.scope = scope;
  }

  public boolean isIgnoreExption()
  {
    return ignoreExption;
  }

  public void setIgnoreExption(boolean ignoreExption)
  {
    this.ignoreExption = ignoreExption;
  }

  public List<IAbsDef> getSubList()
  {
    return subList;
  }

  public void setSubList(List<IAbsDef> subList)
  {
    this.subList = subList;
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "foreach:" + tag + "=" + currentCount;
  }

}
