package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IFunctionDef;
import com.brilliance.eibs.util.StringUtil;

/**
 * @author hujun
 *
 * 自定义反射函数模型
 */
public class ReflectDef
    extends AbsDef
    implements IFunctionDef
{

  private String  method;
  private String  type;
  private String  name;
  private String  clazz;
  private String  error;
  private String  alias;
  private boolean isStatic = true;

  public ReflectDef( String method, String type, String name, String clazz, String error, String alias, boolean isStatic )
  {
    this.method = method;
    this.type = type;
    this.name = name;
    this.clazz = clazz;
    this.error = error;
    this.alias = alias;
    this.isStatic = isStatic;
  }

  public String getMethod()
  {
    return method;
  }

  public void setMethod(String method)
  {
    this.method = method;
  }

  public String getAlias()
  {
    return alias;
  }

  public void setAlias(String alias)
  {
    this.alias = alias;
  }

  public String getType()
  {
    return type;
  }

  public void setType(String type)
  {
    this.type = type;
  }

  public String getName()
  {
    return name;
  }

  public void setName(String name)
  {
    this.name = name;
  }

  public String getClazz()
  {
    return clazz;
  }

  public void setClazz(String clazz)
  {
    this.clazz = clazz;
  }

  public String getError()
  {
    return error;
  }

  public void setError(String error)
  {
    this.error = error;
  }

  public boolean isStatic()
  {
    return isStatic;
  }

  public void setStatic(boolean isStatic)
  {
    this.isStatic = isStatic;
  }

  /**
   * @return
   * 
   * 用于根据静态关系重新构建type字段，主用是用于函数调用检索
   */
  public ReflectDef resetType()
  {
    if (!CONSTRUCTOR_TYPE.equals(method) && !isStatic)
      type = FIELD_TYPE.equals(method) ? clazz : StringUtil.isEmpty(type) ? clazz : clazz + "," + type;
    return this;
  }

  @Override
  public String getUnique()
  {
    return "reflect: " + clazz + "." + name + "[" + type == null ? "" : type + "]";
  }

}
