package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IStepDef;
import com.brilliance.eibs.core.model.ITransactionDef;
import com.brilliance.eibs.core.model.converter.NullStringConverter;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamConverter;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @see IStepDef
 */
@XStreamAlias("step")
@XStreamConverter(NullStringConverter.class)
public class StepDef
    extends AbsDef
    implements IStepDef, Serializable
{
  private static final long         serialVersionUID = 1L;

  private transient ITransactionDef transaction;                               // 隶属交易
  @XStreamAsAttribute
  private String                    id;
  @XStreamAsAttribute
  private String                    level;                                     //每个Step可以设置日志输出级别 debug info error
  @XStreamImplicit
  private List<IAbsDef>              executeList      = new ArrayList<IAbsDef>();

  public String getId()
  {
    return id;
  }

  public void setId(String id)
  {
    this.id = id;

  }

  public ITransactionDef getTransaction()
  {
    return transaction;
  }

  public void setTransaction(ITransactionDef transaction)
  {
    this.transaction = transaction;
  }

  public List<IAbsDef> getExecuteList()
  {
    return executeList;
  }

  public void setExecuteList(List<IAbsDef> executeList)
  {
    this.executeList = executeList;
  }

  public boolean equals(Object obj)
  {
    return EqualsBuilder.reflectionEquals(this, obj);
  }

  public String getLevel()
  {
    return level;
  }

  public void setLevel(String level)
  {
    this.level = level;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "step:" + id;
  }

}
