package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IArgumentDef;
import com.brilliance.eibs.core.model.IValidatorDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@XStreamAlias("validator")
public class ValidatorDef
    extends AbsDef
    implements IValidatorDef, Serializable
{
  private static final long  serialVersionUID = 1L;
  @XStreamAsAttribute
  private String             id;
  @XStreamAsAttribute
  private String             condition;
  @XStreamAsAttribute
  private String             errorCode;
  @XStreamAsAttribute
  private String             description;
  @XStreamImplicit
  private List<IArgumentDef> arguments        = new ArrayList<IArgumentDef>(); //参数列表

  public String getId()
  {
    return id;
  }

  public void setId(String id)
  {
    this.id = id;
  }

  public String getCondition()
  {
    return condition;
  }

  public void setCondition(String condition)
  {
    this.condition = condition;
  }

  public String getErrorCode()
  {
    return errorCode;
  }

  public void setErrorCode(String errorCode)
  {
    this.errorCode = errorCode;
  }

  public String getDescription()
  {
    return description;
  }

  public void setDescription(String description)
  {
    this.description = description;
  }

  public void addArgument(IArgumentDef argumentDef)
  {
    arguments.add(argumentDef);
  }

  public void setArguments(List<IArgumentDef> arguments)
  {
    this.arguments = arguments;
  }

  public List<IArgumentDef> getArguments()
  {
    return this.arguments;
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "validator:" + id;
  }
}
