package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IWhileDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@XStreamAlias("while")
public class WhileDef
    extends AbsDef
    implements IWhileDef, Serializable
{
  private static final long serialVersionUID = 1L;
  @XStreamAsAttribute
  private String            condition;
  @XStreamImplicit
  private List<IAbsDef>     subList          = new ArrayList<IAbsDef>();

  public String getCondition()
  {
    return condition;
  }

  public void setCondition(String condition)
  {
    this.condition = condition;
  }

  public List<IAbsDef> getSubList()
  {
    return subList;
  }

  public void setSubList(List<IAbsDef> subList)
  {
    this.subList = subList;
  }

  public boolean equals(Object obj)
  {
    return EqualsBuilder.reflectionEquals(this, obj);
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "while:" + condition;
  }

}
