package com.brilliance.eibs.core.module;

import com.brilliance.eibs.core.model.IFieldDef;
import com.brilliance.eibs.core.model.IModuleDef;

import java.util.Map;

public abstract class AbsModule
{
  protected Object     obj;
  protected IModuleDef moduleDef;
  protected String     encoding;

  public AbsModule( IModuleDef moduleDef )
  {
    this.encoding = System.getProperty("file.encoding");
    this.moduleDef = moduleDef;
  }

  public AbsModule( String encoding, IModuleDef moduleDef )
  {
    this.encoding = encoding;
    this.moduleDef = moduleDef;
  }

  public AbsModule( Object obj, IModuleDef moduleDef )
  {
    this.encoding = System.getProperty("file.encoding");
    this.obj = obj;
    this.moduleDef = moduleDef;
  }

  public AbsModule( String encoding, Object obj, IModuleDef moduleDef )
  {
    this.encoding = encoding;
    this.obj = obj;
    this.moduleDef = moduleDef;
  }

  /**
   * @param id   模型id
   * @param map 所有模型对象
   * @param etag 通过etag获取Ifield对象
   * @return  IFieldDef对象
   * **/
  public IFieldDef getModuleFieldDefbyEtag(String etag)
  {
    IFieldDef fieldDef = moduleDef.getMap().get(etag);
    return fieldDef;
  }

  public abstract Map<String, Object> packModule();

  public abstract Map<String, Object> unpackModule();

}
