package com.brilliance.eibs.core.service;

/**
 * 系统最后返回消息的处理类 返回失败时,返回内容为系统错误码
 */
public class ResultMsg {
	private boolean success = true; // 返回成功标志
	private Object content; // 返回的内容
	private String returnCode; // 返回码
	private String description;
	private Boolean ignoredException = false;
	private Boolean toException = false;
	private Exception causeException;

	public ResultMsg() {
	}

	public ResultMsg(boolean success) {
		this.success = success;
	}

	/**
	 * 获取成功标志
	 * 
	 * @return
	 */
	public boolean isSuccess() {
		return success;
	}

	/**
	 * 设置成功标志
	 * 
	 * @param success
	 */
	public void setSuccess(Boolean success) {
		this.success = success;
	}

	public Boolean isIgnoredException() {
		return ignoredException;
	}

	public void setIgnoredException(Boolean ignoredException) {
		this.ignoredException = ignoredException;
	}

	public Boolean isToException() {
		return toException;
	}

	public void setToException(Boolean toException) {
		this.toException = toException;
	}

	public Exception getCauseException() {
		return causeException;
	}

	public void setCauseException(Exception causeException) {
		this.causeException = causeException;
	}

	/**
	 * 获取返回内容
	 * 
	 * @return
	 */
	public Object getContent() {
		return content;
	}

	/**
	 * 设置返回内容
	 * 
	 * @param content
	 */
	public void setContent(Object content) {
		this.content = content;
	}

	public String getReturnCode() {
		return returnCode;
	}

	public void setReturnCode(String returnCode) {
		this.returnCode = returnCode;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	// /**
	// * 返回错误码对象
	// * @return
	// */
	// public SysCode getErorr()
	// {
	// if (content instanceof SysCode)
	// {
	// return (SysCode) content;
	// }
	// return null;
	// }
}
