package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.frame.ISocketProxy;
import com.brilliance.eibs.core.service.instance.plugin.JdbcExecutor;
import com.brilliance.eibs.core.service.instance.plugin.JedisProxy;
import com.brilliance.eibs.core.service.instance.plugin.UdpProxy;

import java.sql.Connection;
import java.util.HashMap;
import java.util.Map;

public class GenericResource implements IResource {
	private Connection connection;
	private Connection cntConnection;
	private JdbcExecutor executor;
	private ISocketProxy socketProxy;
	private Object object;
	private Object[] transArgs;
	private String errorcode;
	private String descrption;
	private String description;
	private String interfaceName;
	private String transactionName;
	private Boolean success = true;
	private StringBuffer logbuffer;
	private UdpProxy udpProxy;
	// private Jedis jedis;
	private Exception exception;

	private JedisProxy jedisProxy = new JedisProxy();

	private Map<String, Object> parameters = new HashMap<String, Object>();

	public JdbcExecutor getExecutor() {
		return executor;
	}

	public void setExecutor(JdbcExecutor executor) {
		this.executor = executor;
	}

	public ISocketProxy getSocketProxy() {
		return socketProxy;
	}

	public void setSocketProxy(ISocketProxy socketProxy) {
		this.socketProxy = socketProxy;
	}

	public Connection getConnection() {
		return connection;
	}

	public void setConnection(Connection connection) {
		this.connection = connection;
	}

	public Connection getCntConnection() {
		return cntConnection;
	}

	public void setCntConnection(Connection cntConnection) {
		this.cntConnection = cntConnection;
	}

	public Object getObject() {
		return this.object;
	}

	public void setObject(Object object) {
		this.object = object;
	}

	public Object[] getTransArgs() {
		return transArgs;
	}

	public void setTransArgs(Object[] transArgs) {
		this.transArgs = transArgs;
	}

	public String getErrorcode() {
		return errorcode;
	}

	public Boolean getSuccess() {
		return success;
	}

	public void setSuccess(Boolean success) {
		this.success = success;
	}

	public String getInterfaceName() {
		return interfaceName;
	}

	public void setInterfaceName(String interfaceName) {
		this.interfaceName = interfaceName;
	}

	public String getTransactionName() {
		return transactionName;
	}

	public void setTransactionName(String transactionName) {
		this.transactionName = transactionName;
	}

	public String getDescrption() {
		return descrption;
	}

	public void setErrorcode(String errorcode) {
		this.errorcode = errorcode;
	}

	public void setDescrption(String descrption) {
		this.descrption = descrption;
	}

	public StringBuffer getLogbuffer() {
		return logbuffer;
	}

	public void setLogbuffer(StringBuffer logbuffer) {
		this.logbuffer = logbuffer;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public UdpProxy getUdpProxy() {
		return udpProxy;
	}

	public void setUdpProxy(UdpProxy udpProxy) {
		this.udpProxy = udpProxy;
	}

	@Override
	public Object getResourceParameter(String key) {
		return parameters.get(key);
	}

	@Override
	public void addResourceParameter(String key, Object value) {
		parameters.put(key, value);
	}

	/*
	 * public Jedis getJedis() { return jedis; }
	 * 
	 * public void setJedis(Jedis jedis) { this.jedis = jedis; }
	 */

	@Override
	public JedisProxy getJedisProxy() {
		return jedisProxy;
	}

	@Override
	public void setJedisProxy(JedisProxy jedisProxy) {
		this.jedisProxy = jedisProxy;
	}

	public Exception getException() {
		return exception;
	}

	public void setException(Exception exception) {
		this.exception = exception;
	}
}
