package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.model.IFunctionDef;
import com.brilliance.eibs.core.model.impl.ReflectDef;

/**
 * @author hujun
 *
 * 反射方法流程实例
 */
public class MethodFunctionInstance
    extends FunctionInstance
{

  public MethodFunctionInstance( IFunctionDef def )
  {
    super(def);
  }

  @Override
  protected Object executeFunctionDef(Object[] params)
  {
    ReflectDef reflectDef = (ReflectDef) def;
    if (reflectDef.isStatic())
      return invokeStaticMethod(reflectDef.getClazz(), reflectDef.getName(), params);
    Object[] objs = new Object[params.length - 1];
    System.arraycopy(params, 1, objs, 0, params.length - 1);
    return invokeMethod(params[0], reflectDef.getName(), objs);
  }

}
