package com.brilliance.eibs.core.service.instance.plugin;

import java.sql.Connection;
import java.sql.SQLException;

public class ConnectionAdaptor extends AbsCloseConnection {

	private boolean isClosed = false;
	private Connection connection;
	private boolean isMybatis = false;

	public ConnectionAdaptor(Connection connection) {
		// super();
		this.connection = connection;
	}

	public boolean isMybatis() {
		return isMybatis;
	}

	public void setMybatis(boolean isMybatis) {
		this.isMybatis = isMybatis;
	}

	public Connection getConnection() {
		return connection;
	}

	public void close() throws SQLException {
		if (null != connection && !connection.isClosed()) {
			connection.setAutoCommit(true);
			connection.close();
		}
		isClosed = true;
	}

	public void rollback() throws SQLException {
		if (null != connection && !connection.isClosed())
			connection.rollback();
	}

	public boolean isClosed() throws SQLException {
		if (connection == null) {
			isClosed = true;
			return isClosed;
		}
		isClosed = connection.isClosed();
		return isClosed;
	}
}
