package com.brilliance.eibs.core.service.instance.plugin;

import com.brilliance.eibs.core.exception.InterfaceException;
import com.brilliance.eibs.util.StringUtil;
import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.net.ftp.FTPReply;
import org.slf4j.Logger;

import java.io.*;
import java.util.*;

public class FtpExcutor extends FTPClient {
    private FTPClient ftpClient = new FTPClient();
    private String ip;
    private String port;
    private String username;
    private String password;
    private String remotePath;
    private String localPath;
    private String encoding;
    protected Logger logger;
    private String arc;
    private boolean FLG = true;
    private String x = "";
    private Map<String, String> map = new HashMap<String, String>();
    private String rules = "";

    public Logger getLogger() {
        return logger;
    }

    public void setLogger(Logger logger) {
        this.logger = logger;
    }

    public FtpExcutor(String encoding, Logger logger) {
        this.encoding = encoding;
        this.logger = logger;
    }

    public String getIp() {
        return ip;
    }

    public FTPClient getFtpClient() {
        return ftpClient;
    }

    public void setFtpClient(FTPClient ftpClient) {
        this.ftpClient = ftpClient;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getEncoding() {
        return encoding;
    }

    public void setEncoding(String encoding) {
        this.encoding = encoding;
    }

    public String getPort() {
        return port;
    }

    public void setPort(String port) {
        this.port = port;
    }

    public String getArc() {
        return arc;
    }

    public void setArc(String arc) {
        this.arc = arc;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getRemotePath() {
        return remotePath;
    }

    public void setRemotePath(String remotePath) {
        this.remotePath = remotePath;
    }

    public String getLocalPath() {
        return localPath;
    }

    public void setLocalPath(String localPath) {
        this.localPath = localPath;
    }

    /**
     * 本方法用户登录远程的FTP服务器
     *
     * @param url      :表示FTP的IP地址
     * @param port     :FTP服务器端口，默认端口为21
     * @param userName :登录FTP的用户名
     * @param password :登录FTP的密码
     * @return FTPClient:返回为FTPClient对象
     */
    public boolean loginFtp(String url, int port, String userName, String password) {
        try {
            ftpClient.connect(url, port);
            ftpClient.setControlEncoding(encoding);
            // FTPClientConfig ftpConfig = new
            // FTPClientConfig(FTPClientConfig.SYST_NT);
            // ftpConfig.setServerLanguageCode("zh");
            ftpClient.login(userName, password);
            int reply = 0;
            reply = ftpClient.getReplyCode();
            logger.info(reply + "");
            if (FTPReply.isPositiveCompletion(reply)) {
                logger.info("FTP 登录成功！");
                return true;
            } else {
                logger.info("FTP 登录失败！");
                return false;
            }
        } catch (Exception e) {
            if (ftpClient != null)
                try {
                    closeConnections(ftpClient);
                } catch (IOException e1) {
                    logger.error("login error:", e);
                }
            throw new InterfaceException("01201", "ftp login error.", e);
        }

    }

    /**
     * @param ftpc :退出FTP登录
     * @return boolean :是否已经关闭连接
     * @throws IOException
     */
    public boolean closeConnections(FTPClient ftpc) throws IOException {
        boolean bool = false;
        ftpc.logout();
        return bool;
    }

    // 上传整个目录到FTP的指定目录中
    public void uploadDirFiles(String dirPath, String toRemotePath) throws IOException {
        if (dirPath != null && !dirPath.equals("")) {
            // 建立上传目录的File对象
            File dirFile = new File(dirPath);
            // 判断File对象是否为目录类型
            if (dirFile.isDirectory()) {
                // 如果是目录类型。
                // 在FTP上创建一个和File对象文件相同名称的文件夹
                String toRemotePathlist[] = toRemotePath.split("\\/");
                String name = "";
                for (String currentpath : toRemotePathlist) {
                    name = name + currentpath + "/";
                    name = getRealPath(name);
                    ftpClient.makeDirectory(name);
                }

                // boolean f = ftpClient.makeDirectory(toRemotePath + "//" +
                // dirFile.getName() + "//");

                // 获得File对象中包含的子目录数组
                File[] subFiles = dirFile.listFiles();
                // 路径
                String path = "";
                path = toRemotePath + "//" + dirFile.getName();

                if (FLG == true) {
                    x = dirFile.getName();
                    FLG = false;
                }
                logger.info(getRealPath(path));
                // 判断数组是否为空
                if (subFiles != null && subFiles.length > 0) {
                    // 遍历整个File数组
                    for (int i = 0; i < subFiles.length; i++) {
                        // 判断是否为目录类型
                        if (subFiles[i].isDirectory()) {
                            // 如果为目录类型
                            // 跳转到FTP的根目录层级
                            ftpClient.changeWorkingDirectory("//");
                            // 在FTP上建立相同的目录名称

                            // 不包括文件夹
                            String s1 = (path + "//" + subFiles[i].getName());
                            // 解决上传文件夹如果最底层目录与FTP服务器文件夹有同名的文件夹 会出现文件夹上传混乱的情况
                            // TODO modified by yangrui 20150918
                            if (FLG == true) {
                                ftpClient.makeDirectory(getRealPath(getNoRootPath(s1, x)));
                                uploadDirFiles(subFiles[i].getAbsolutePath(), getRealPath(getNoRootPath(path, x)));
                            } else {
                                ftpClient.makeDirectory(getRealPath(s1));
                                uploadDirFiles(subFiles[i].getAbsolutePath(), getRealPath(path));
                            }

                            // 带有文件夹
                            // ftpClient.makeDirectory(path + "//" +
                            // subFiles[i].getName());
                            // 递归调用自身方法，进行到下一层级的目录循环
                            // uploadDirFiles(subFiles[i].getAbsolutePath(),
                            // path);
                        } else {
                            // 如果为文件类型
                            // 建立一个文件输出流对象
                            FileInputStream input = new FileInputStream(subFiles[i]);
                            // 调用文件上传方法，将文件上传到FTP上
                            // uploadFileToFtp(subFiles[i].getName(), input,
                            // path + "//");
                            // uploadFileToFtp(subFiles[i].getName(), input,
                            // path.replace("abc", "") + "//");
                            uploadFileToFtp(subFiles[i].getName(), input, getRealPath(getNoRootPath(path, x) + "/"));
                            // 关闭文件输入流
                            input.close();
                        }
                    }
                }
            } else {
                // 如果为文件类型
                // 建立一个文件输出流对象
                FileInputStream input = new FileInputStream(dirFile);
                // 调用文件上传方法，将文件上传到FTP上
                uploadFileToFtp(dirFile.getName(), input, toRemotePath);
                // 关闭文件输入流
                input.close();
            }
        }
    }

    /**
     * 方法用于上传文件到FTP服务器的指定文件夹中
     *
     * @param fileName  :上传文件的名称
     * @param input     :上传文件的输入流对象
     * @param toFtpPath :上传到FTP的目的路径
     * @return boolean:表示上传是否成功
     */
    public boolean uploadFileToFtp(String fileName, InputStream input, String toFtpPath) {
        boolean bool = false;
        try {
            // 使得能够处理中文编码
            /*
             * fileName = new String(fileName.getBytes("GBK"), "ISO-8859-1");
             * toFtpPath = new String(toFtpPath.getBytes("GBK"), "ISO-8859-1");
             */
            fileName = new String(fileName.getBytes(encoding), encoding);
            toFtpPath = new String(toFtpPath.getBytes(encoding), encoding);
            // 服务器上建立上传报文路径
            String toRemotePathlist[] = toFtpPath.split("\\/");
            String name = "";
            for (String currentpath : toRemotePathlist) {
                name = name + currentpath + "/";
                if (name != null) {
                    if (!name.trim().equals("/") && !name.trim().equals("//") && !name.trim().equals("\\"))
                        ftpClient.makeDirectory(getRealPath(name));
                }

            }
            // ftpClient.makeDirectory(toFtpPath);
            // 转到上传文件的FTP目录中
            if (ftpClient.changeWorkingDirectory(getRealPath(toFtpPath))) {
                /*
                 * File pf = new File(toFtpPath).getParentFile();
                 * System.out.println(pf.getPath());
                 * System.out.println(pf.getPath().equals("\\"));
                 * System.out.println(); if (pf != null &&
                 * !pf.getPath().trim().equals
                 * ("/")&&!pf.getPath().trim().equals("\\")) {
                 * System.out.println("111");
                 * ftpClient.makeDirectory(pf.getPath()); }
                 */

            }
            // 设置处理文件的类型为字节流的形式
            ftpClient.setFileType(FTP.BINARY_FILE_TYPE);
            // 如果缺省该句 传输txt正常 但图片和其他格式的文件传输出现乱码
            ftpClient.storeFile(fileName, input);
            input.close();
            bool = true;
        } catch (IOException e) {
            bool = false;
            e.printStackTrace();
        }
        return bool;
    }

    // 本方法用于下载FTP上的目录结构到本地中
    // 本方法用于下载FTP上的目录结构到本地中
    public void addToMap(String remotePath, String rules) throws IOException {
        remotePath = getRealPath(remotePath);
        if (remotePath != null && !remotePath.equals("")) {
            // 获得FTPFile对象数组
            FTPFile[] ftpFiles = ftpClient.listFiles(new String(remotePath.getBytes(encoding), encoding));
            if (ftpFiles != null && ftpFiles.length > 0) {
                for (int i = 0; i < ftpFiles.length; i++) {
                    String nam = ftpFiles[i].getName();
                    if (nam.equals("") || nam.equals(".") || nam.equals("..")) {
                        continue;
                    }

                    FTPFile subFile = ftpFiles[i];
                    // 判断是否为目录结构
                    if (subFile.isDirectory()) {
                        String fileName = subFile.getName();
                        if (!StringUtil.isEmpty(rules)) {
                            String[] argsrules = rules.split(",");
                            for (String currentrule : argsrules) {
                                if (fileName.startsWith(currentrule)) {
                                    map.put(getRealPath(remotePath + "/" + fileName), getRealPath(remotePath + "/" + fileName));
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public void downloadDirFiles(String fname, String remotePath, String localPath, String arc, String rule) throws IOException {
        this.rules = rule;
        remotePath = getRealPath(remotePath);
        if (this.remotePath == null)
            this.remotePath = remotePath;
        addToMap(this.remotePath, rules);
        this.arc = arc;
        if (remotePath != null && !remotePath.equals("")) {
            // 在本地建立一个相同的文件目录
            File localFile = new File(localPath);
            localFile.mkdirs();
            // 获得目录在本地的绝对路径
            localPath = localFile.getAbsolutePath();
            logger.info(localPath);
            // 获得FTPFile对象数组
            FTPFile[] ftpFiles = ftpClient.listFiles(new String(remotePath.getBytes(encoding), encoding));

            if (ftpFiles != null && ftpFiles.length > 0) {

                for (int i = 0; i < ftpFiles.length; i++) {
                    if (StringUtil.isEmpty(fname)) {
                        String nam = ftpFiles[i].getName();
                        if (nam.equals("") || nam.equals(".") || nam.equals("..")) {
                            continue;
                        }

                        FTPFile subFile = ftpFiles[i];
                        // 判断是否为目录结构
                        if (subFile.isDirectory()) {
                            String fileName = subFile.getName();
                            if (StringUtil.isEmpty(rule)) {
                                if (isnotinnerarc(subFile.getName()))
                                    // 如果为目录结构
                                    // 调用自身方法，进行下一层级目录循环
                                    downloadDirFiles(fname, remotePath + "/" + subFile.getName(), localPath + "/" + subFile.getName(), arc, rule);
                                // 清除空目录 TODO modified by yangrui 20150917
                                boolean deleteboolean = ftpClient.removeDirectory(remotePath + "/" + subFile.getName());
                            } else {
                                if (isMyFileDirectoyName(remotePath, fileName, rule)) {
                                    if (isnotinnerarc(subFile.getName()))
                                        // 如果为目录结构
                                        // 调用自身方法，进行下一层级目录循环
                                        downloadDirFiles(fname, remotePath + "/" + subFile.getName(), localPath + "/" + subFile.getName(), arc, rule);
                                }
                            }
                        } else {
                            // 如果不为目录结构,为文件类型
                            FileOutputStream outputStream = new FileOutputStream(new File(localPath + "/" + subFile.getName()));
                            // 调用下载方法对文件进行下载
                            downloadFileFromFtp(remotePath, subFile.getName(), outputStream);
                            // 关闭文件输出流
                            outputStream.close();
                        }
                    } else {
                        // 如果不为目录结构,为文件类型
                        FileOutputStream outputStream = new FileOutputStream(new File(localPath + "/" + fname));
                        // 调用下载方法对文件进行下载
                        downloadFileFromFtp(remotePath, fname, outputStream);
                        // 关闭文件输出流
                        outputStream.close();
                        return;
                    }
                }
            }
        }
    }

    public void downSingleFile(String fname, String remotePath, String localPath, String arc, String rule) throws IOException {
        this.rules = rule;
        remotePath = getRealPath(remotePath);
        if (this.remotePath == null)
            this.remotePath = remotePath;
        addToMap(this.remotePath, rules);
        this.arc = arc;
        if (remotePath != null && !remotePath.equals("")) {
            // 在本地建立一个相同的文件目录
            File localFile = new File(localPath);
            localFile.mkdirs();
            // 获得目录在本地的绝对路径
            localPath = localFile.getAbsolutePath();
            logger.info(localPath);
            // 获得FTPFile对象数组
            FTPFile[] ftpFiles = ftpClient.listFiles(new String(remotePath.getBytes(encoding), encoding));
            // 如果不为目录结构,为文件类型
            FileOutputStream outputStream = new FileOutputStream(new File(localPath + "/" + fname));
            // 调用下载方法对文件进行下载
            downloadFileFromFtp(remotePath, fname, outputStream);
            // 关闭文件输出流
            outputStream.close();
            return;

        }

    }

    public boolean isMyFileDirectoyName(String remotepath, String dirnam, String rule) {
        if (StringUtil.isEmpty(rule))
            return false;

        /*
         * String[] argsrules = rule.split(","); for (String currentrule :
         * argsrules) {
         *
         * if (dirnam.startsWith(currentrule)) { return true; }
         *
         * }
         */
        String path = getRealPath(remotepath + "/" + dirnam);

        Iterator<String> iter = map.keySet().iterator();

        while (iter.hasNext()) {
            String key = iter.next();
            if (path.contains(key)) {
                return true;
            }
        }
        return false;
    }

    /**
     * 判断是否为内部 备份目录
     **/
    public boolean isnotinnerarc(String fileName) {
        boolean b = true;
        if (arc == null)
            return false;
        if (!arc.startsWith("./"))
            return b;
        String s = arc.substring(2);
        String[] ss = s.split("/");
        for (String string : ss) {
            if (string.trim() == "")
                continue;
            if (string.trim().equals(fileName)) {
                return false;
            }
        }
        return b;
    }

    /**
     * 方法用于从FTP服务器中下载文件
     *
     * @param ftpUrl      :下载文件所处FTP中路径
     * @param fileName    :下载的文件名称
     * @param outputSream :下载文件的输出流对象
     * @return boolean :表示是否下载成功
     */
    public boolean downloadFileFromFtp(String ftpUrl, String fileName, OutputStream outputStream) {
        boolean bool = false;
        try {

            String s = "";
            if (arc.startsWith("./"))
                s = ftpUrl + "/" + arc.substring(2);
            else
                s = this.arc + "/" + ftpUrl;

            String mm = "";
            String[] s1 = ftpUrl.split("/");
            for (int i = 0; i < s1.length; i++) {
                if (!(s1[i].trim().equals(""))) {
                    mm = "../" + mm;
                }
            }

            String m = "";
            String[] ss = null;
            if (this.arc.startsWith("./"))
                ss = (this.remotePath + "/" + arc.substring(2) + "/" + ftpUrl.substring(ftpUrl.indexOf(remotePath) + remotePath.length())).split("/");
            else
                ss = (this.arc + "/" + ftpUrl.substring(ftpUrl.indexOf(remotePath) + remotePath.length())).split("/");
            for (String string : ss) {
                if (string.trim() == "")
                    continue;
                if (m.endsWith("/"))
                    m = m + string;
                else
                    m = m + "/" + string;
                ftpClient.makeDirectory(getRealPath(m));
            }
            ftpUrl = getRealPath(ftpUrl);
            ftpClient.changeWorkingDirectory(ftpUrl);
            FTPFile[] ftpFile = ftpClient.listFiles();

            for (int i = 0; i < ftpFile.length; i++) {
                logger.info("ftp list File=" + ftpFile[i].getName() + "&&subfileName=" + fileName);
                if (fileName.equals(ftpFile[i].getName())) {
                    ftpClient.retrieveFile(new String(ftpFile[i].getName().getBytes(encoding), encoding), outputStream);
                    outputStream.flush();
                    outputStream.close();
                    String path1 = ftpFile[i].getName();
                    String path2 = mm + m + "/" + ftpFile[i].getName();
                    path2 = getRealPath(path2);
                    if (!StringUtil.isEmpty(arc))
                        bool = ftpClient.rename(path1, path2);

                }
            }
            bool = true;
        } catch (IOException e) {
            e.printStackTrace();
            bool = false;
        }
        return bool;
    }

    /**
     * 方法用户删除FTP上的指定的文件
     *
     * @param fileUrl  :文件在FTP中的路径
     * @param fileName :文件的名称
     * @return boolean:删除是否成功
     */
    public boolean deleteFileOnFtp(String fileUrl, String fileName) {
        boolean bool = false;
        try {
            ftpClient.changeWorkingDirectory(getRealPath(fileUrl));
            FTPFile[] ftpFiles = ftpClient.listFiles();
            logger.info(ftpFiles.length+"");
            for (int i = 0; i < ftpFiles.length; i++) {
                if (fileName.equals(ftpFiles[i].getName())) {
                    ftpClient.deleteFile(fileName);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bool;
    }

    /**
     * 判断指定文件中是否存在相同名称的文件
     *
     * @param remotePath :FTP上的远程目录
     * @param fileName   :文件名称
     * @return boolean :判断是否存在相同名称
     */
    public boolean isSameName(String remotePath, String fileName) {
        boolean bool = false;
        try {
            FTPFile[] ftpFiles = ftpClient.listFiles();
            logger.info(ftpFiles.length+"");
            ftpClient.changeWorkingDirectory(remotePath);
            for (int i = 0; i < ftpFiles.length; i++) {
                if (fileName.equals(ftpFiles[i].getName())) {
                    logger.info("存在和指定文件相同名称的文件");
                    bool = true;
                } else {
                    bool = false;
                }
            }
        } catch (Exception e) {
            bool = false;
        }
        return bool;
    }

    /**
     * 更改文件名称
     */
    public String changeName(String remotePath, String fileName, String newName) {
        if (isSameName(remotePath, fileName)) {
            fileName = fileName + "." + newName;
        }
        return fileName;
    }

    public String getNoRootPath(String ss, String tmp) {
        String[] as = ss.split("\\/");
        List<String> list = new ArrayList<String>();
        for (int i = 0; i < as.length; i++) {
            as[i] = as[i].replace("/", "").trim();
            list.add(as[i]);
        }
        for (int i = 0; i < as.length; i++) {
            if (as[i].equals(tmp)) {
                list.remove(i);
                break;
            }
        }
        StringBuffer sbb = new StringBuffer();
        for (String string : list) {
            if (!string.equals(""))
                sbb.append("/" + string);
        }
        return getRealPath(sbb.toString() + "/");
    }

    public String getRealPath(String path) {
        return path.replaceAll("[//]+", "/");
    }

}
