package com.brilliance.eibs.core.service.instance.plugin;

import com.brilliance.eibs.core.frame.ISocketProxy;
import com.brilliance.eibs.extension.mina.client.MinaNioClient;
import org.apache.mina.core.session.IoSession;

import java.io.IOException;
import java.net.Socket;

public class MinaSocketClientAdaptor implements ISocketProxy {

	private MinaSocketProxy proxy;
	private MinaNioClient client;

	public MinaSocketClientAdaptor(MinaNioClient client,String charset,int timeout) {
		this.client = client;
		proxy = new MinaSocketProxy(charset,timeout,this.client);
	}

	public void setMessage(Object message) {
		proxy.setMessage(message);
	}

	public void setSession(IoSession session) {
		proxy.setSession(session);
	}

	public void setReceiveTimeout(int receiveTimeout) {
		proxy.setReceiveTimeout(receiveTimeout);
	}

	@Override
	public void close() {
		proxy.close();
		client.close();
	}

	@Override
	public void setEncoding(String encoding) {
		proxy.setEncoding(encoding);
	}

	@Override
	public String getDataStream(int len) throws IOException {
		return proxy.getDataStream(len);
	}

	@Override
	public Object[] readDataByBuffer() throws IOException {
		return proxy.readDataByBuffer();
	}

	@Override
	public byte[] getDataStreamBytes(int len) throws IOException {
		return proxy.getDataStreamBytes(len);
	}

	@Override
	public String getStrBySocketStream() throws IOException {
		return proxy.getStrBySocketStream();
	}

	@Override
	public void send(Object sendMsg) throws IOException {
		proxy.send(sendMsg);
	}

	@Override
	public void skip(long len) throws IOException {
		proxy.skip(len);
	}

	@Override
	public boolean isConnected() {
		return proxy.isConnected();
	}

	@Override
	public Socket getSocket() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object getObject() throws IOException {
		// TODO Auto-generated method stub
		return proxy.getObject();
	}

}
