package com.brilliance.eibs.extension.mina.codec;

import org.apache.mina.core.buffer.IoBuffer;
import org.apache.mina.core.session.IoSession;
import org.apache.mina.filter.codec.CumulativeProtocolDecoder;
import org.apache.mina.filter.codec.ProtocolDecoderOutput;

import java.nio.charset.Charset;

public class CustomDecoder extends CumulativeProtocolDecoder {
	private int headlength;

	public CustomDecoder(Charset charset, int headlength) {
		this.headlength = headlength;
	}

	@Override
	protected boolean doDecode(IoSession session, IoBuffer in,
			ProtocolDecoderOutput out) throws Exception {
		if (in.remaining() > 0) {// 有数据时，读取前headlength字节判断消息长度
			byte[] sizeBytes = new byte[headlength];
			in.mark();// 标记当前位置，以便reset
			in.get(sizeBytes, 0, headlength);
			int size = Integer.parseInt(new String(sizeBytes).trim());
			in.reset();
			if (size > in.remaining()) {
				return false;
			} else {
				int totalsize=size+headlength;
				byte[] bytes = new byte[totalsize];
				in.get(bytes, 0, totalsize);
				out.write(IoBuffer.wrap(bytes));
				// 如果读取内容后还粘了包，就让父类再重读 一次，进行下一次解析
				if (in.remaining() > 0) {
					return true;
				}
			}
		}
		return false;
	}

}
