package com.brilliance.eibs.extension.mina.filter;

import org.apache.mina.core.filterchain.IoFilterAdapter;
import org.apache.mina.core.session.IoSession;
import org.apache.mina.core.write.WriteRequest;


public abstract class SimpleConditionFilter extends IoFilterAdapter {


    @Override
    public void messageReceived(NextFilter nextFilter, IoSession session, Object message)
            throws Exception {
        if (condition())
            nextFilter.messageReceived(session, message);
        else
            blockSession(session);
    }


    protected abstract boolean condition();

    @Override
    public void messageSent(NextFilter nextFilter, IoSession session, WriteRequest writeRequest)
            throws Exception {
        if (condition())
            nextFilter.messageSent(session, writeRequest);
        else
            blockSession(session);
    }


    private void blockSession(IoSession session) {
        session.closeNow();
    }

}
