package com.brilliance.eibs.factory;

import com.brilliance.eibs.core.model.IFunctionDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.core.service.instance.*;

/**
 * @author hujun
 *
 * 自定义函数流程工厂，用于自动根据传入函数模型，返回特定的处理流程
 */
public class FunctionInstanceFactory
{

  public static IFunctionInstance createInstance(IFunctionDef def, Context context)
  {
    if (IFunctionDef.CONSTRUCTOR_TYPE.equals(def.getMethod()))
      return new ConstructorFunctionInstance(def);
    if (IFunctionDef.METHOD_TYPE.equals(def.getMethod()))
      return new MethodFunctionInstance(def);
    if (IFunctionDef.FIELD_TYPE.equals(def.getMethod()))
      return new FieldFunctionInstance(def);
    return new CustomFunctionInstance(def, context);
  }
}
