package com.brilliance.eibs.factory.parser.impl;

import org.apache.commons.io.FileUtils;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.XMLWriter;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;

public class WriteXMLFlag
{
  public boolean overwrite = false;

  public void setOverwrite(boolean overwrite) {
      this.overwrite = this.overwrite || overwrite;
  }

  public void writeXML(URL path, Object doc) {
      XMLWriter writer = null;
      FileOutputStream fos = null;
      File f = FileUtils.toFile(path);
      long l = f.lastModified();
      try {
          // OutputFormat xmlFormat = OutputFormat.createPrettyPrint();
          // xmlFormat.setEncoding("utf-8");
          fos = new FileOutputStream(f);
          writer = new XMLWriter(fos);
          if (doc instanceof Document)
              writer.write(doc);
          else if (doc instanceof Element)
              writer.write(((Element) doc).getDocument());
          else
              throw new RuntimeException("dynamic encrypt, wrong parameter type.");
      } catch (IOException e) {
          throw new RuntimeException("dynamic encrypt, rewriting file failed.", e);
      } finally {
          try {
              if (writer != null) writer.close();
              if (fos != null) fos.close();
          } catch (IOException e) {
              throw new RuntimeException("dynamic encrypt, rewriting file failed.", e);
          }
      }
      f.setLastModified(l);
  }
}
