package com.brilliance.eibs.listener.helpers;

import org.slf4j.Logger;

/**
 * @author hujun
 *
 * 
 */
public abstract class Watchdog extends Thread {
    private static final long DEFAULT_DELAY = 5000L;
    protected Logger log;
    private long delay = DEFAULT_DELAY;
    boolean interrupted = false;

    public Watchdog(Logger log) {
        this.log = log;
    }


    public void run() {
        log.info("Startup file listener thread.");
        while (!interrupted) {
            try {
                Thread.sleep(this.delay);
            } catch (InterruptedException e) {
                log.error("File listener thread abort.", e);
                interrupted = true;
                break;
            }
            checkAndConfigure();
        }
        log.info("File listener thread ends.");
    }


    public void esbrun() {
        log.info("Startup file listener thread.");
        checkAndConfigure();
        log.info("File listener thread ends.");
    }


    public void setDelay(long delay) {
        this.delay = delay;
    }

    public abstract void checkAndConfigure();
}
