package com.brilliance.eibs.main;

import org.apache.commons.io.IOUtils;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Scanner;

public class ServerMgr
{
  public static void main(String[] args)
      throws UnknownHostException, IOException
  {

    if (args.length < 2)
    {
      System.out.println("argument not enough.");
      return;
    }
    String host = args[0];
    if (!args[1].matches("\\d+"))
    {
      System.out.println("port should be a number.");
      return;
    }
    int port = Integer.parseInt(args[1]);
    Socket socket = new Socket(host, port);

    String cmd = null;
    if (args.length < 3)
    {
      cmd = "-help";
    }
    else
    {
      cmd = args[2];
    }
    String msg = String.format("%04d", cmd.length()) + cmd;
    //    System.out.println("send msg [" + msg + "] to " + host + ":" + port);
    IOUtils.write(msg.getBytes(), socket.getOutputStream());
    byte[] retBytes = new byte[4];
    IOUtils.readFully(socket.getInputStream(), retBytes);
    int a = Integer.parseInt(new String(retBytes));
    retBytes = new byte[a];
    IOUtils.readFully(socket.getInputStream(), retBytes);
    System.out.println(new String(retBytes, "utf-8"));
    IOUtils.closeQuietly(socket);
    while (true)
    {
      System.out.println("Please enter your command:");
      cmd = "";
      Scanner input = new Scanner(System.in);
      cmd = new StringBuffer(input.nextLine()).toString();
      System.out.println("cmd="+cmd);
      if (cmd.equals("quit"))
      {
        break;
      }
      msg = String.format("%04d", cmd.length()) + cmd;
      socket = new Socket(host, port);
      //    System.out.println("send msg [" + msg + "] to " + host + ":" + port);
      IOUtils.write(msg.getBytes(), socket.getOutputStream());
      retBytes = new byte[4];
      IOUtils.readFully(socket.getInputStream(), retBytes);
      a = Integer.parseInt(new String(retBytes));
      retBytes = new byte[a];
      IOUtils.readFully(socket.getInputStream(), retBytes);
      System.out.println(new String(retBytes, "utf-8"));
      IOUtils.closeQuietly(socket);
    }

  }
}
