package com.brilliance.eibs.main;

import com.brilliance.eibs.core.model.ITransactionDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.core.service.instance.plugin.UdpProxy;

import java.net.DatagramPacket;
import java.net.DatagramSocket;

public class UdpHandle
    extends Client
    implements Runnable
{

  private String   interfaceName;
  private String   transactionName;
  private String   revStr;
  private UdpProxy udpProxy;
  private byte[] buffer;

  public UdpHandle( String interfaceName, String transactionName, String revStr, DatagramPacket dataPacket, DatagramSocket socket )
  {
    this.interfaceName = interfaceName;
    this.transactionName = transactionName;
    this.revStr = revStr;
    this.udpProxy = new UdpProxy(dataPacket, socket);

  }
  
  public UdpHandle( String interfaceName, String transactionName, byte[] buffer, DatagramPacket dataPacket, DatagramSocket socket )
  {
    this.interfaceName = interfaceName;
    this.transactionName = transactionName;
    this.buffer = buffer;
    this.udpProxy = new UdpProxy(dataPacket, socket);

  }

  @Override
  public void execute(ITransactionDef transDef, Context context)
  {
    context.getResource().setUdpProxy(udpProxy);
    super.execute(transDef, context);
  }

  @Override
  public void run()
  {
    call(interfaceName, transactionName, buffer);
  }

}
