package com.brilliance.eibs.packet;

import com.brilliance.eibs.core.frame.ISocketProxy;

import java.io.IOException;

public class Packet
{
  private PacketHeader  packetHeader;
  private PacketScanner packetScanner;
  private int           packetlength;
  private String        encode;

  public Packet( ISocketProxy socketProxy, String encoding, int datalen )
  {
    this.packetlength = datalen;
    this.encode = encoding;
    this.packetScanner = new PacketScanner(socketProxy, datalen);
    this.packetHeader = new PacketHeader();
  }

  public int getPacketlength()
  {
    return packetlength;
  }

  public void setEncode(String encode)
  {
    this.encode = encode;
  }

  public String getEncode()
  {
    return encode;
  }

  public byte[] readHeader(String endTag)
      throws Exception
  {
    packetHeader.recycle();
    packetHeader.readHeader(packetScanner, endTag);
    char[] head = packetHeader.getHeader();
    if (head.length > 0)
    {
      return (new String(head)).getBytes(encode);
    }
    return new byte[0];
  }
  
  public byte[] readBody() throws Exception{
    char[] body=packetScanner.getRemaining();
    if(body.length>0){
      return (new String(body)).getBytes(encode);
    }
    return new byte[0]; 
  }

  public void fillPacket() throws IOException
  {
    this.packetScanner.fillPacket();
  }
}
