package com.brilliance.eibs.quartz;

import com.brilliance.eibs.core.model.IPropertyDef;
import com.brilliance.eibs.main.Server;

public class StopServerHandle extends Thread {

	private CronTask task;
	private long startTime;
	private long totalSleepTime = 0;
	private boolean done = false;

	private boolean currentStop = false;

	public void setStop() {
		this.currentStop = true;
	}

	public StopServerHandle(CronTask task, long startTime, boolean done) {
		this.task = task;
		this.startTime = startTime;
		this.done = done;
	}

	@Override
	public void run() {
		// Thread.currentThread().setName("monitorTask" + ":" +
		// Thread.currentThread().getName());
		long threadTimeOut = 0;
		IPropertyDef propertyDef = task.getTaskDef().getProperty("timeout");
		if (propertyDef == null)
			threadTimeOut = 1000 * 60 * 60;
		else
			threadTimeOut = Long.parseLong(propertyDef.getValue());
		threadTimeOut = threadTimeOut / 1000;
		while (true && (!currentStop)) {
			long endTime = System.currentTimeMillis();
			/*
			 * if (done) { startTime = endTime; done = false; }
			 */
			int result = (int) ((endTime - startTime) / 1000);
			if ((result > threadTimeOut)) {
				System.out.println("task break!!!");
				// Server.stopServermap.remove(task.getTaskDef().getId());
				task.setStop();
				// System.out.println("XXXX=" + task.isInterrupted());
				Server.startTask(task.getTaskDef());
				break;
			}
			try {
				Thread.sleep(1000);
				totalSleepTime = totalSleepTime + 1000;
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		System.out.println("monitor finished ");
	}

	public long getStartTime() {
		return startTime;
	}

	public void setStartTime(long startTime) {
		this.startTime = startTime;
	}

	public long getTotalSleepTime() {
		return totalSleepTime;
	}

	public void setTotalSleepTime(long totalSleepTime) {
		this.totalSleepTime = totalSleepTime;
	}

	public boolean isDone() {
		return done;
	}

	public void setDone(boolean done) {
		this.done = done;
	}

}
