package com.brilliance.eibs.server;

/**
 * 服务接口
 * 
 * @author xiaoyuanzhen
 *
 */
public interface IServerInstance {
	static final String TRUST_IP_SYMBOL = "trust_ip";
	static final String THREAD_POOL_SIZE_SYMBOL = "thread_pool_size";
	static final String REQUEST_QUEUE_LEN_SYMBOL = "request_queue_len";
	static final String PATH_SYMBOL = "path";
	static final String PORT_SYMBOL = "port";
	static final String IP_SYMBOL = "ip";
	static final String LINKS_SYMBOL = "links";
	static final String HEARTBEAT_SYMBOL = "heartbeat";
	static final String HEAD_TAG_LEN_SYMBOL = "head_tag_len";
	static final String INTERVAL_SYMBOL = "interval";
	static final String DETECT_SYMBOL = "detect";
	static final String FIN_SYMBOL = "fin";
	static final String TIMEOUT_SYMBOL = "timeout";
	static final String URI_SYMBOL = "uri";
	static final String INITPARA = "initparam";
	static final String CLASS_SYMBOL = "class";
	static final String METHOD_SYMBOL = "method";
	static final String READ_FLG = "in";
	static final String WRITE_FLG = "out";
	static final String RECORD_SPLIT_SYMBOL = "record_split";
	static final String FIELD_SPLIT_SYMBOL = "field_split";
	static final String CONNECT_TIMEOUT_SYMBOL = "connect_timeout";
	static final String RECEIVE_TIMEOUT_SYMBOL = "receive_timeout";
	static final String DELAY_TIME = "delay_time";
	static final String TYPE = "type";
	static final String HEAD_LENGTH = "headLength";
	static final String LOG_FLAG = "############";
	static final String BUFFER_SIZE = "buffersize";
	static final String SERVER_URL = "server_url";
	static final String USER_NAME = "user_name";
	static final String PASSWORD = "password";
	static final String QUEUE = "queue";
	// ------------added by weicong on 2016/4/01 -----------
	static final String KEY_STORE = "keystore";
	static final String KEY_STORE_PASS = "keystorepass";
	static final String TRUST_STORE = "truststore";
	static final String TRUST_STORE_PASS = "truststorepass";
	static final String KEY_STORE_TYPE = "keystoretype";
	static final String SSL_CONTEXT_ALGO = "algorithms";
	static final String CHARSET = "charset";
	static final String HEADLEN = "headlen";
	static final String SPLITE = "splite";

	/**
	 * 是否报文报文头 false true,默认为true
	 **/
	static final String HAS_CONTAIN_HEAD = "has_head";
	/**
	 * 报文头长度是二进制还是十进制 2/10，默认为10
	 **/
	static final String HEAD_LEN_TYPE = "head_len_type";

	/**
	 * 报文头长度
	 **/
	static final String HEAD_LEN = "head_len";

	/**
	 * 报文头长度是否包含报文头true false
	 **/
	static final String IS_CONTAIN_HEAD_LEN = "is_contain_head_len";

	/**
	 * 报文头和报文体填充区域长度：默认为0
	 **/
	static final String FILL_LEN = "fill_len";

	/**
	 * 报文头长度是否包含报文头和报文体之间数据的长度 true false
	 **/
	static final String IS_CONTAIN_FILL_LEN = "is_contain_fill_len";

	/**
	 * 报文体位移量 默认为0, -1为减去1个长度，+1为增加1个长度
	 **/
	static final String BODY_OFFSET = "body_offset";

	static final String ENCODING = "encoding";

	static final String HEAD_LEN_TYPE_10 = "10";
	static final String HEAD_LEN_TYPE_2 = "2";
	static final int DEFAULT_IO_THREADS = Runtime.getRuntime()
            .availableProcessors() + 1;

	void close();

	void start();
}
