package com.brilliance.eibs.server.channel.model.impl;

import com.brilliance.eibs.server.channel.server.ChannelServer;
import com.brilliance.eibs.server.connection.Connection;
import com.brilliance.eibs.server.connection.FilterChain;
import org.apache.commons.io.IOUtils;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class AsyncFixedChannel
    extends AsyncChannel
{
  private int         length;
  private FilterChain chain;

  public AsyncFixedChannel( Connection in, Connection out, ChannelServer server, int length, FilterChain chain )
  {
    super(in, out, server);
    this.length = length;
    this.chain = chain;
  }

  @Override
  protected void detailTransfer(Connection in, Connection out, Direction direction)
      throws IOException
  {

    InputStream is = in.getInputStream();
    OutputStream os = out.getOutputStream();
    byte[] b = new byte[length];
    IOUtils.readFully(is, b);
    b = new byte[Integer.valueOf(new String(b))];
    IOUtils.readFully(is, b);
    if (Direction.REQUEST.equals(direction))
      b = chain.doRequestFilterChain(b);
    if (Direction.RESPONSE.equals(direction))
      b = chain.doResponseFilterChain(b);
    int len = b.length;
    String strLen = String.format("%0" + length + "d", len);
    IOUtils.write(strLen, os);
    IOUtils.write(b, os);

  }
}
