package com.brilliance.eibs.server.connection.impl;

import org.apache.commons.io.IOUtils;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class DuplexConnection
    extends CloseableConnection
{

  private Socket s;

  public DuplexConnection( Socket s )
  {
    this.s = s;
  }

  @Override
  public void close()
  {
    IOUtils.closeQuietly(s);
    isClosed = true;
  }

  @Override
  public InputStream getInputStream()
      throws IOException
  {
    return s.getInputStream();
  }

  @Override
  public OutputStream getOutputStream()
      throws IOException
  {
    return s.getOutputStream();
  }

}
