package com.brilliance.eibs.server.link_v2_0;

public abstract class Detect
    implements Runnable
{
  protected long    interval;
  private long    nextExecutionTime;
  private boolean isInterrupted = true;

  @SuppressWarnings("unused")
  private Detect()
  {}

  public Detect( long interval )
  {
    this.interval = interval;
  }

  @Override
  public void run()
  {
    setNextExecutionTime(System.currentTimeMillis());
    while (!isInterrupted)
      if (isExecutionTime())
        process();
  }

  abstract void process();

  private boolean isExecutionTime()
  {
    long interval = nextExecutionTime - System.currentTimeMillis();
    try
    {
      if (interval > 0)
        Thread.sleep(interval);
    }
    catch (InterruptedException e)
    {
      interrupted();
    }
    return interval <= 0;
  }

  void setNextExecutionTime(long now)
  {
    nextExecutionTime = now + interval;
  }

  boolean isInterrupted()
  {
    return isInterrupted;
  }

  void interrupted()
  {
    isInterrupted = true;
  }

  public void setInterrupted(boolean isInterrupted)
  {
    this.isInterrupted = isInterrupted;
  }

}
