package com.brilliance.eibs.server.link_v2_0;

import org.slf4j.Logger;

import java.io.IOException;
import java.util.concurrent.locks.Lock;

public interface Link
{
  void write(byte[] data)
      throws IOException;

  byte[] read(int len)
      throws IOException;

  void build()
      throws IOException, InterruptedException;

  void rebuild()
      throws IOException, InterruptedException;

  void close();

  boolean isReady();

  void setTimeout(int timeout);

  void setInterval(long interval);

  Heartbeat getHeartbeat();

  void setHeartbeat(Heartbeat heartbeat);

  void setReceiveDetect(ReceiveDetect receiveDetect);

  ReceiveDetect getReceiveDetect();

  Lock getLock();

  Logger getLogger();

  void shutdown();
}
