package com.brilliance.eibs.server.link_v2_0;

import com.brilliance.eibs.core.service.ResultMsg;
import com.brilliance.eibs.main.Client;

public class LinkClient
    implements Runnable
{
  private byte[]       pack;
  private LinkDispatch dispatch;

  @SuppressWarnings("unused")
  private LinkClient()
  {}

  public LinkClient( LinkDispatch dispatch, byte[] pack )
  {
    this.dispatch = dispatch;
    this.pack = pack;
  }

  @Override
  public void run()
  {
    String interfaceName = dispatch.getInterfaceName();
    String transcationId = dispatch.getTranscationId();
    Client client = new Client();
    ResultMsg result = client.call(interfaceName, transcationId, pack);
    if (dispatch.isReturn())
    {
      Object obj = result.getContent();
      byte[] content = null;
      if (obj instanceof byte[])
        content = (byte[]) obj;
      if (obj instanceof String)
        content = ((String) obj).getBytes();
      if (content != null)
        dispatch.response(content);
    }
  }

}
