package com.brilliance.eibs.server.link_v2_0;

import java.io.IOException;
import java.util.concurrent.locks.Lock;

public class ReceiveDetect
    extends Detect
{
  private Link link;

  public ReceiveDetect( long interval, Link link )
  {
    super(interval);
    this.link = link;
  }

  public void setLink(Link link)
  {
    this.link = link;
  }

  @Override
  void process()
  {
    Lock lock = link.getLock();
    lock.lock();
    try
    {
      link.getLogger().debug("Data is not received within " + interval + " msec...");
      link.rebuild();
    }
    catch (IOException e1)
    {
      interrupted();
    }
    catch (InterruptedException e1)
    {
      interrupted();
    }
    finally
    {
      lock.unlock();
    }
  }

}
