package com.brilliance.eibs.util;

import com.brilliance.eibs.el.CommonFunctionUtils;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.FieldPosition;

public class NumberUtil {
	public static String decimalFormat(String decimal) {

		return NumberUtil.decimalFormat(decimal, 2);
	}

	public static String decimalFormat(String decimal, int num) {
		String string = "#0." + StringUtil.repeat("0", num);
		DecimalFormat df = new DecimalFormat(string);
		StringBuffer stringBuffer = new StringBuffer("");
		df.format(Double.valueOf(decimal), stringBuffer, new FieldPosition(num));
		decimal = stringBuffer.toString();
		return decimal;
	}

	public static String decimalFormat(Object decimal, int num) {
		String dec = decimal.toString();
		return decimalFormat(dec, num);
	}

	public static String accurateDivide(String dividend, String divisor, int digits) {
		BigDecimal decimal = BigDecimal.valueOf(Double.valueOf(dividend));
		return decimal.divide(BigDecimal.valueOf(Double.valueOf(divisor)), digits, BigDecimal.ROUND_HALF_UP).toString();
	}

	public static double accurateDivide(double dividend, double divisor, int digits) {
		BigDecimal decimal = BigDecimal.valueOf(dividend);
		return decimal.divide(BigDecimal.valueOf(divisor), digits, BigDecimal.ROUND_HALF_UP).doubleValue();
	}

	public static double round(double v, int scale) {

		if (scale < 0)

		{

			throw new IllegalArgumentException("The scale must be a positive integer or zero");

		}

		BigDecimal b = new BigDecimal(Double.toString(v));

		BigDecimal one = new BigDecimal("1");

		return b.divide(one, scale, BigDecimal.ROUND_HALF_UP).doubleValue();

	}

	public static int getMax(int[] values) {
		if (values != null) {
			int max = Integer.MIN_VALUE;
			for (int i : values) {
				max = max > i ? max : i;
			}
			return max;
		} else {
			return -1;
		}
	}

	/**
	 * @param 金额
	 * @param 对方需要的小数点位数
	 * @param 是否需要根据小数点进行扩容
	 * */
	public static String formatAmt(String amt, int dot) {
		String s = NumberUtil.decimalFormat(amt, dot);
		return s.replace(".", "");
	}

	public static void main(String[] args) {

		System.out.println(CommonFunctionUtils.decimalFormat2(null, 2));
		String a = "0.3849999999996";
		System.out.println(NumberUtil.round(Double.valueOf(a), 5));

		String format = NumberUtil.decimalFormat("123");
		System.out.println(format);
		format = NumberUtil.decimalFormat("123.4555");
		System.out.println(format);

		format = NumberUtil.decimalFormat("123.4555", 5);
		System.out.println(format);
		format = NumberUtil.decimalFormat("0.123", 5);
		System.out.println(format);

		float parseFloat = Float.parseFloat("883.5301");
		double mairujrat = parseFloat / Integer.parseInt("100");
		System.out.println(mairujrat);// 丢失小数为8.83530044555664

		BigDecimal decimal = BigDecimal.valueOf(883.5301);
		mairujrat = decimal.divide(BigDecimal.valueOf(100), 6, BigDecimal.ROUND_HALF_UP).doubleValue();
		System.out.println(mairujrat);

		String mrjr = NumberUtil.decimalFormat(String.valueOf(mairujrat), 6);
		System.out.println(mrjr);

		System.out.println(NumberUtil.accurateDivide("883.530100", "100", 6));

		System.out.println(Math.ceil(16 / 10));

		System.out.println(NumberUtil.formatAmt("123.23", 3));
	}
}
