package com.brilliance.eibs.util;

import com.brilliance.eibs.el.CommonFunctionUtils;
import org.apache.commons.io.FileUtils;
import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.app.VelocityEngine;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StringWriter;
import java.net.URL;
import java.util.Map;

public class TemplateUtil {

	public static void makeFileByTemplate(String template, Map<String, Object> cache, String outPut, String encode) throws IOException {
		ClassLoader classLoader = CommonFunctionUtils.class.getClassLoader();
		URL url = classLoader.getResource("template/");
		if (url != null) {
			VelocityEngine ve = new VelocityEngine();
			ve.setProperty(VelocityEngine.FILE_RESOURCE_LOADER_PATH, url.getPath());
			ve.setProperty(Velocity.OUTPUT_ENCODING, encode);
			ve.setProperty(Velocity.INPUT_ENCODING, encode);
			ve.init();
			VelocityContext context = new VelocityContext();
			Template vt = ve.getTemplate(template);
			context.put("vm", cache);
			StringWriter sw = new StringWriter();
			vt.merge(context, sw);
			FileUtils.write(new File(outPut), sw.toString().replaceAll("\\\\\\\\", "\\$"), encode, false);
		} else {
			throw new FileNotFoundException("没有在template目录下找到模板文件：" + template);
		}
	}

	public static void makeFileByTemplate2(String template, Map<String, Object> cache, String outPut, String encode) throws IOException {
		ClassLoader classLoader = CommonFunctionUtils.class.getClassLoader();
		URL url = classLoader.getResource("template/");
		if (url != null) {
			VelocityEngine ve = new VelocityEngine();
			ve.setProperty(VelocityEngine.FILE_RESOURCE_LOADER_PATH, url.getPath());
			ve.setProperty(Velocity.OUTPUT_ENCODING, encode);
			ve.setProperty(Velocity.INPUT_ENCODING, encode);
			ve.init();
			VelocityContext context = new VelocityContext();
			Template vt = ve.getTemplate(template);
			for (String key : cache.keySet()) {
				context.put(key, cache.get(key));
			}
			StringWriter sw = new StringWriter();
			vt.merge(context, sw);
			FileUtils.write(new File(outPut), sw.toString().replaceAll("\\\\\\\\", "\\$"), encode, false);
		} else {
			throw new FileNotFoundException("没有在template目录下找到模板文件：" + template);
		}
	}
}
