package com.brilliance.eibs.util.mbeans;

import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.factory.parser.ConfigParser;
import com.brilliance.eibs.factory.parser.ParserFactory;
import com.brilliance.eibs.main.Server;
import com.brilliance.eibs.util.LogUtil;
import org.slf4j.Logger;

import java.util.List;

public class ServerMBean
{
  private static Logger      logger      = LogUtil.getLogger("services");
  final static ServerMBean serverMBean = new ServerMBean();

  public String showAllServers()
  {
    ConfigParser parser = null;
    parser = ParserFactory.getInstance(logger);
    List<IServiceDef> serviceDefs = parser.getServiceDefs("services");
    String line = System.getProperty("line.separator");
    StringBuffer sb = new StringBuffer();
    sb.append(String.format("%-30s%-10s%-40s", "service", "state", "description") + line);
    sb.append("--------------------------------------------------------------------------------" + line);
    for (IServiceDef serviceDef : serviceDefs)
    {
      String id = serviceDef.getId();
      sb.append(String.format("%-30s", id));
      if (Server.servers.containsKey(id))
        sb.append(String.format("%-10s", "on"));
      else
        sb.append(String.format("%-10s", "off"));
      sb.append(serviceDef.getDescription() + line);
    }
    logger.debug("showAllServers is called");
    return sb.toString();
  }
}
