package com.brilliance.eibs.util.mbeans;

import java.text.DecimalFormat;

public class TypeFormat {
	
	//字节数换算
	public static String[] sizeFormat(long fileSize)
	{
        DecimalFormat df = new DecimalFormat("#0.0");
        String[] str;
        
		if (fileSize < 1024) {
			str = new String[]{df.format((double) fileSize),"B"};
		} else if (fileSize < 1048576) {
			str = new String[]{df.format((double) fileSize / 1024),"KB"};
		} else if (fileSize < 1073741824) {
			str = new String[]{df.format((double) fileSize / 1048576),"MB"};
		} else {
			str = new String[]{df.format((double) fileSize / 1073741824),"GB"};
		}
		
		return str;
	}
	
	/**
	 * 毫秒转换
	 * @param msecond 毫秒
	 * @return
	 */
	public static String[] timeFormat(Object msecond)
	  {
	    String html = "0毫秒";
	    if (msecond != null)
	    {
	      Long s = (Long) msecond;
	      String format;
	      Object[] array;
	      Integer hours = (int) (s / (60 * 60 * 1000));
	      Integer minutes = (int) (s / (60 * 1000) - hours * 60);
	      Integer seconds = (int) (s / 1000 - minutes * 60 - hours * 60 * 60);
	      Integer mseconds = (int) (s - seconds * 1000 - minutes * 60 * 1000 - hours * 60 * 60 * 1000);
	      if (hours > 0)
	      {
	        format = "%1$,d时%2$,d分%3$,d秒%4$,d毫秒";
	        array = new Object[]{hours, minutes, seconds, mseconds};
	      }
	      else if (minutes > 0)
	      {
	        format = "%1$,d分%2$,d秒%3$,d毫秒";
	        array = new Object[]{minutes, seconds, mseconds};
	      }
	      else if (seconds > 0)
	      {
	        format = "%1$,d秒%2$,d毫秒";
	        array = new Object[]{seconds, mseconds};
	      }
	      else
	      {
	        format = "%1$,d毫秒";
	        array = new Object[]{mseconds};
	      }
	      html = String.format(format, array);
	    }
	    return new String[]{html,""};
	  }
}
