package com.brilliance.eibs.util.soap;

import org.slf4j.Logger;

import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.HandlerResolver;
import javax.xml.ws.handler.PortInfo;
import java.util.ArrayList;
import java.util.List;


public class SoapMessageHandlerResolver implements HandlerResolver {
    
    private String serviceName = "";
    private Logger log;
    
    public SoapMessageHandlerResolver(String serviceName,Logger log) {
        this.serviceName = serviceName;
        this.log = log;
    }
    
    @Override
    public List<Handler> getHandlerChain(PortInfo portInfo) {
        
        List<Handler> handlerChain = new ArrayList<Handler>();
        SoapMessageHandler soapMessageHandler = new SoapMessageHandler(this.serviceName,this.log);
        handlerChain.add(soapMessageHandler);
        
        return handlerChain;
    }
}
